% This graph description is an example how to use the TimeBufferDropNode for video editing.
% The first two values of the in-output specify the start time in seconds and mseconds of the
% first buffer that is passed throug and the last two values the end time. These time specidifcations
% refers to the mpeg timestamps in the file.
% Only the mpeg data between these timestamps are converted to divx and stored in an avi file.
%
%command:       clic video_edit2.gd -i <Source-MPEG-file> -o <Target-AVI-File>

GenericReadNode 
        $ seekBytes(342000000) OUTPUT_INITIALIZED
! MPEGDemuxNode 
{
      { ["mpeg_video0"]  ! TimedBufferDropNode
                           $ addInOutPoint(17654,300,17721,400) CONSTRUCTED
                         ! MPEGVideoDecodeNode 
                         ! YUVDeInterlaceNode 
                         ! VideoScalerNode 
	                        @ Format(x_resolution=768, y_resolution=576, ratio_x=768, ratio_y=576)
                         ! FramerateConverterNode 
                                $ setTimeOffsetMillisecs(-400) ACTIVATED
                         ! DivX4EncodeNode 
                                @ Format (bitrate = 2800000) 
                         ! ["video"]  
      }
      { ["mpeg_audio0"]  ! TimedBufferDropNode
                                $ addInOutPoint(17654,300,17721,400) CONSTRUCTED
                         ! MPEGAudioDecodeNode 
                         ! MPEGAudioEncodeNode 
                                @ Format (bitrate = 128000) 
                         ! ["audio"]
      }
}
  AVMuxNode 
! AVIWriteNode

