/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:         
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#ifndef __CONFIGSTATE__
#define __CONFIGSTATE__

#include <vector>
#include <string>

#include"../../main/application.hpp"
#include "../../main/mmboxstate.hpp"
#include "nmm/plugins/video/osd/manager/OSDElements/doublelistunit.hpp"


namespace NMM {

  class ConfigState : public MMBoxState {

  public:

    /**
     * constructor needs a string id that identifies the class
     * \param id the menu id string
     */
    ConfigState( string, MMBoxApplication* );
    ~ConfigState();

    Result Up();
    Result Down();
    Result Left();
    Result Right();
    Result Return();
    Result Back();
    Result doCreate( string );
    Result doKill();
    Result doInitialize( string );
    Result doUninitialize();
    Result receiveMessage( string message ); 
    
    /**
     * show option in options list
     * \param id ID of teh option in MMBoxConfig
     */
    Result showOption( string id, string shortform );
    
  protected:
    map<string, string> shown_options;
    
    IOSDManager*      manager;
    IWidgetFactory*   factory;
    DoubleListUnit*   dlistunit;
    MMBoxEventDispatcher*  dispatcher;
    MMBoxConfig*      config;
    
    void initList();
    void deleteWindow();
    void createWindow();
  };

}

#endif //__CONFIGSTATE__
