#include "NavigationHandler.hpp"
#include "nmm/utils/utils.hpp"

#include <fstream>

namespace NMM{
  NavigationHandler::NavigationHandler()
    : WebRequestHandler("navigation")
  {}
  NavigationHandler::~NavigationHandler(){}
  
  void NavigationHandler::doGet (WebServerRequest *, WebServerResponse *pResponse){
    //cerr << "Method  : " << pRequest->getMethod() << endl;
    //cerr << "Protocol: " << pRequest->getProtocol() << endl;
    //cerr << "URI     : " << pRequest->getRequestURI() << endl;
    //cerr << "Query   : " << pRequest->getQueryString() << endl;
    //cerr << "RemAddr : " << pRequest->getRemoteAddress() << endl;

    pResponse->write("<html><head>");
    //pResponse->write("<title>Test-Site</title>");
    
    ifstream f((getNMMResourceDir() + "/mmbox/webhandler/navigation.css").c_str());
    char line[1000];
    
    if(f.fail()){
    }else{
      while(!f.eof()){
        f.getline(line, 1000);
        pResponse->write(string(line));
      }
      f.close(); 
    }

    pResponse->write("</head>");
    pResponse->write("<body>");
    time_t now = time(NULL);
    char t[10];
    strftime(t, sizeof(t), "%Y%m%d", localtime(&now));
    pResponse->write("<a href='/epg?date="+ string(t) + "' target='events'>TVGuide</a>");
    pResponse->write("<br>");
    pResponse->write("<a href='/record' target='events'>Recorder</a>");
    pResponse->write("<br>");
    pResponse->write("<a href='/record?newTimer' target='events'>New Timer</a>");
    pResponse->write("<br>");
    pResponse->write("<a href='/transcode' target='events'>Transcoder Overview</a>");
    pResponse->write("</body></html>");
    
  }

  void NavigationHandler::doPost(WebServerRequest *, WebServerResponse *){

  }
}
