/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        Marco Lohse <mlohse@cs.uni-sb.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#ifndef _NMM_ISIGNALRECEIVER_HPP_
#define _NMM_ISIGNALRECEIVER_HPP_

namespace NMM {
  enum Signal { FREE_QUEUE_SLOT = 1, FREE_DOWNSTR_QUEUE_SLOT = 1, FREE_UPSTR_QUEUE_SLOT  = 2, 
		QUEUE_NOT_EMPTY = 3, INPUT_QUEUE_NOT_EMPTY   = 3, OUTPUT_QUEUE_NOT_EMPTY = 4,
		START, STOP, DEACTIVATE, WORKING, PRODUCING };

  class ISignalReceiver {
  public:
    ISignalReceiver() {};
    virtual ~ISignalReceiver() {};

    virtual void receiveSignal(Signal ) = 0;
  };
}

#endif
