/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        Marco Lohse <mlohse@cs.uni-sb.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#ifndef _NMM_SIMPLEOUTPUTJACK_HPP_
#define _NMM_SIMPLEOUTPUTJACK_HPP_

#include "OutputJack.hpp"

namespace NMM {

  class Message;
  class InputJack;
  /**
   * This is a very simple "pushing" input jack, which simply pushes
   * all incoming buffers along to its parent node.
   */
  class SimpleOutputJack : public OutputJack {

  public:

    /**
     * The main constructor. This constructor only sets the parent,
     * not the partner.
     * \param parent the parent node.
     */
    SimpleOutputJack(Node* node, const string& jack_tag = "default");

    /**
     * The destructor.
     */
    virtual ~SimpleOutputJack();

    virtual SimpleOutputJack* clone() const;

    virtual Result receiveMessage(Message* message, const IMessageSender* jack = 0);

    virtual Result sendMessage(Message *message);

  };

}

#endif // _NMM_SIMPLEINPUTJACK_HPP_
