/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        Marco Lohse <mlohse@cs.uni-sb.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, 
 * USA.
 */

%{
#include <stdio.h>
#include <stdlib.h>
#include "ihpp.h"
#include "ihppimpl.h"
#include "icpp.h"
#include "icppimpl.h"
unsigned int lineno;
%}
%x COMM
%%
[ \t]*"/*"        { BEGIN COMM; yylval=strdup(yytext); return COMMENT; }
<COMM>"*/"[ \t]*\n { BEGIN 0; lineno++; yylval=strdup(yytext); return COMMENT;  }
<COMM>"*/"         { BEGIN 0; yylval=strdup(yytext);  return COMMENT; }
<COMM>[\n\t]       { lineno++; yylval=strdup(yytext);  return COMMENT; }
<COMM>.            { yylval=strdup(yytext);  return COMMENT; }
\/\/.*\n                yylval=strdup(yytext); return COMMENT;
\*                      return POINTER;
\&                      return REFERENCE;
\#include[ ]*\"[\/a-zA-Z0-9\.]*\.idl\"  yylval=strdup(yytext); return INCLUDE;
(-?0.0)|(-?[0-9]*\.[0-9]+)        yylval=strdup(yytext); return FLOATNUMBER;
(-?0)|(-?[1-9]+[0-9]*)  yylval=strdup(yytext); return NUMBER;
[0-9]+[a-zA-Z]+         yylval=strdup(yytext); return NUMBERWORD;
\=                      return EQUALS;
enum                    return ENUM;
unsigned                return UNSIGNED;
signed                  return SIGNED;
module                  return MODULE;
interface               return INTERFACE;
required                return REQUIRED;
limited                 return LIMITED;
outofband               return OUTOFBAND;
instream                return INSTREAM;
in|out|inout            yylval=strdup(yytext); return INOUT;  
const                   yylval=strdup(yytext); return CONST;
raises                  yylval=strdup(yytext); return THROW;
[a-zA-Z_][a-zA-Z_0-9]*    yylval=strdup(yytext); return WORD;
\"[^"\n]*["\n]            yylval=strdup(yytext); return STRING;
\|                      return OR;
\<                      return OTEMPLATE;
\>                      return CTEMPLATE;
\{                      return OBRACE;
\}                      return EBRACE;
\(                      return OBRACKET;
\)                      return EBRACKET; 
,                       return COMMA;
;                       return SEMICOLON;
\:\:                      return TWOCOLON;
\:                       return COLON;
\n                      lineno++;
[ \t]+                  /* ignore whitespace */;
%%



















