
#ifndef NMM_IMMBoxApplicationImpl_HPP
#define NMM_IMMBoxApplicationImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IMMBoxApplication.hpp"

#include "IMMBoxStateImpl.hpp"

namespace NMM
{

  class IMMBoxApplicationImpl  : public virtual NMMObject { 
  public:
    IMMBoxApplicationImpl() { addInterface(new IMMBoxApplication(*this)); registerEvents(); };

    virtual ~IMMBoxApplicationImpl() {};

  protected:

    virtual string getStateSessionLocation(const string& id) = 0;

    virtual IMMBoxState* createDistState(const string& id) = 0;

    virtual void deleteDistState(const string& id) = 0;


  private:
    void registerEvents();
  };

}

#endif
