
#include "IMute.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IMute::mute() /* in-stream */ 
      throw(const Exception&)
  {
    Event event("IMute::mute");
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void IMute::unmute() /* in-stream */ 
      throw(const Exception&)
  {
    Event event("IMute::unmute");
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* IMute::IMute_type = "IMute";
  TIFactoryObject<IMute > __IMute_prototype("IMute");


  const char* IMute::mute_event = "IMute::mute";
  Event* IMute::create_mute()
  {

    return new Event("IMute::mute");
  }

  const char* IMute::unmute_event = "IMute::unmute";
  Event* IMute::create_unmute()
  {

    return new Event("IMute::unmute");
  }



}


