
#ifndef NMM_IMuteImpl_HPP
#define NMM_IMuteImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IMute.hpp"


namespace NMM
{

  class IMuteImpl  : public virtual NMMObject { 
  public:
    IMuteImpl() { addInterface(new IMute(*this)); registerEvents(); };

    virtual ~IMuteImpl() {};

  protected:
    /**
     * Mutes an audio source or sink
     */

    virtual void mute() /* in-stream */  = 0;
    /**
     * Un-mutes an audio source or sink
     */

    virtual void unmute() /* in-stream */  = 0;


  private:
    void registerEvents();
  };

}

#endif
