
#ifndef NMM_IMPEGDemux_HPP
#define NMM_IMPEGDemux_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class IMPEGDemux : virtual public Interface { 
  public:
    IMPEGDemux() {  setTypeInfo(TypeInfo(IMPEGDemux::IMPEGDemux_type, "NMM")); };

    IMPEGDemux(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IMPEGDemux::IMPEGDemux_type, "NMM")); setEventReceiver(parent); };

    virtual ~IMPEGDemux() {};

    static const char* IMPEGDemux_type;

    virtual  string getInterfaceType() const { return IMPEGDemux_type; }

    Interface* copy() const { return new IMPEGDemux(*this); }
    static const char* setVideoStream_event;
    static const char* setAudioStream_event;
    static const char* setSPUStream_event;
    static const char* setDVDMode_event;

    virtual void setVideoStream(const int& stream)
      throw(const Exception&);

    virtual void setAudioStream(const int& stream)
      throw(const Exception&);

    virtual void setSPUStream(const int& stream)
      throw(const Exception&);

    virtual void setDVDMode(const bool& stream)
      throw(const Exception&);


  };

  typedef auto_ptr<IMPEGDemux> IMPEGDemux_var;




}

#endif
