
#ifndef NMM_IStreamJumpImpl_HPP
#define NMM_IStreamJumpImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IStreamJump.hpp"


namespace NMM
{

  class IStreamJumpImpl  : public virtual NMMObject { 
  public:
    IStreamJumpImpl() { addInterface(new IStreamJump(*this)); registerEvents(); };

    virtual ~IStreamJumpImpl() {};

  protected:

    virtual Result fastForward(const int& value) /* in-stream */  = 0;

    virtual Result streamJump(const int& value) /* in-stream */  = 0;
    /**
     * Send only n I-Frames.
     * Tells the decoder to send only the n decoded I-frames
     * (usefull for fast-forward)
     * n = 0 means normal buffer processing
     */

    virtual Result sendIFramesOnly(const int& n) /* in-stream */  = 0;


  private:
    void registerEvents();
  };

}

#endif
