
#include "IFilterNode.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IFilterNode::setEnabled(const bool& enable)
      throw(const Exception&)
  {
    TInValue<bool > enable_value(enable, false);
    Event event("IFilterNode::setEnabled", &enable_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  bool IFilterNode::isEnabled()
      throw(const Exception&)
  {
    TOutValue<bool > return_value;
    Event event("IFilterNode::isEnabled");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* IFilterNode::IFilterNode_type = "IFilterNode";
  TIFactoryObject<IFilterNode > __IFilterNode_prototype("IFilterNode");


  const char* IFilterNode::setEnabled_event = "IFilterNode::setEnabled";
  const char* IFilterNode::isEnabled_event = "IFilterNode::isEnabled";


}


