
#include "IFormatChange.hpp"
#include "nmm/base/InterfaceFactory.hpp"

#include "nmm/base/format/Property.hpp"

namespace NMM
{
  
  
  Result IFormatChange::setFormat(const Format& new_format) /* in-stream */ 
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<Format > new_format_value(new_format, false);
    Event event("IFormatChange::setFormat", &new_format_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* IFormatChange::IFormatChange_type = "IFormatChange";
  TIFactoryObject<IFormatChange > __IFormatChange_prototype("IFormatChange");


  const char* IFormatChange::setFormat_event = "IFormatChange::setFormat";
  Event* IFormatChange::create_setFormat(const Format& new_format)
  {
    TInValue<Format >* new_format_value = new TInValue<Format >();
    new_format_value->setValue(new_format);

    return new Event("IFormatChange::setFormat", new_format_value);
  }



}


