
#ifndef NMM_INamedImpl_HPP
#define NMM_INamedImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "INamed.hpp"


namespace NMM
{

  class INamedImpl  : public virtual NMMObject { 
  public:
    INamedImpl() { addInterface(new INamed(*this)); registerEvents(); };

    virtual ~INamedImpl() {};

  protected:

    virtual void setName(const string& value) = 0;

    virtual string getName() const = 0;

    virtual void setErrorStream(const string& filname, const int& debug_level) = 0;

    virtual void setDebugStream(const string& filname, const int& debug_level) = 0;

    virtual void setWarningStream(const string& filename, const int& debug_level) = 0;

    virtual void setMessageStream(const string& feilname, const int& debug_level) = 0;


  private:
    void registerEvents();
  };

}

#endif
