
#include "IQueuedImpl.hpp"


namespace NMM
{
  
  void IQueuedImpl::registerEvents()
  {
  
    getEventDispatcher().registerEvent(IQueued::getSize_event, new TEDObject1<IQueuedImpl, string, unsigned int(IQueuedImpl:: * )(const string&) const, unsigned int >(this, &IQueuedImpl::getSize));
  
    getEventDispatcher().registerEvent(IQueued::getMaxSize_event, new TEDObject1<IQueuedImpl, string, unsigned int(IQueuedImpl:: * )(const string&) const, unsigned int >(this, &IQueuedImpl::getMaxSize));
  
    getEventDispatcher().registerEvent(IQueued::setMaxSize_event, new TEDObject2<IQueuedImpl, unsigned int, string, Result(IQueuedImpl:: * )(const unsigned int&, const string&), Result >(this, &IQueuedImpl::setMaxSize));
  
    getEventDispatcher().registerEvent(IQueued::getMode_event, new TEDObject1<IQueuedImpl, string, IQueued::Mode(IQueuedImpl:: * )(const string&) const, IQueued::Mode >(this, &IQueuedImpl::getMode));
  
    getEventDispatcher().registerEvent(IQueued::setMode_event, new TEDObject2<IQueuedImpl, IQueued::Mode, string, Result(IQueuedImpl:: * )(const IQueued::Mode&, const string&), Result >(this, &IQueuedImpl::setMode));

  }
  
  void IBiDirQueuedNodeImpl::registerEvents()
  {
  
    getEventDispatcher().registerEvent(IBiDirQueuedNode::getDownstreamSize_event, new TEDObject1<IBiDirQueuedNodeImpl, string, unsigned int(IBiDirQueuedNodeImpl:: * )(const string&) const, unsigned int >(this, &IBiDirQueuedNodeImpl::getDownstreamSize));
  
    getEventDispatcher().registerEvent(IBiDirQueuedNode::getDownstreamMaxSize_event, new TEDObject1<IBiDirQueuedNodeImpl, string, unsigned int(IBiDirQueuedNodeImpl:: * )(const string&) const, unsigned int >(this, &IBiDirQueuedNodeImpl::getDownstreamMaxSize));
  
    getEventDispatcher().registerEvent(IBiDirQueuedNode::getDownstreamMode_event, new TEDObject1<IBiDirQueuedNodeImpl, string, IQueued::Mode(IBiDirQueuedNodeImpl:: * )(const string&) const, IQueued::Mode >(this, &IBiDirQueuedNodeImpl::getDownstreamMode));
  
    getEventDispatcher().registerEvent(IBiDirQueuedNode::setDownstreamMaxSize_event, new TEDObject2<IBiDirQueuedNodeImpl, unsigned int, string, Result(IBiDirQueuedNodeImpl:: * )(const unsigned int&, const string&), Result >(this, &IBiDirQueuedNodeImpl::setDownstreamMaxSize));
    getEventDispatcher().addLimited(IBiDirQueuedNode::setDownstreamMaxSize_event, INode::CONSTRUCTED);
  
    getEventDispatcher().registerEvent(IBiDirQueuedNode::setDownstreamMode_event, new TEDObject2<IBiDirQueuedNodeImpl, IQueued::Mode, string, Result(IBiDirQueuedNodeImpl:: * )(const IQueued::Mode&, const string&), Result >(this, &IBiDirQueuedNodeImpl::setDownstreamMode));
    getEventDispatcher().addLimited(IBiDirQueuedNode::setDownstreamMode_event, INode::CONSTRUCTED);
  
    getEventDispatcher().registerEvent(IBiDirQueuedNode::unlimitDownstreamSize_event, new TEDObject0<IBiDirQueuedNodeImpl, Result(IBiDirQueuedNodeImpl:: * )(), Result >(this, &IBiDirQueuedNodeImpl::unlimitDownstreamSize));
  
    getEventDispatcher().registerEvent(IBiDirQueuedNode::limitDownstreamSize_event, new TEDObject0<IBiDirQueuedNodeImpl, Result(IBiDirQueuedNodeImpl:: * )(), Result >(this, &IBiDirQueuedNodeImpl::limitDownstreamSize));
  
    getEventDispatcher().registerEvent(IBiDirQueuedNode::getUpstreamSize_event, new TEDObject1<IBiDirQueuedNodeImpl, string, unsigned int(IBiDirQueuedNodeImpl:: * )(const string&) const, unsigned int >(this, &IBiDirQueuedNodeImpl::getUpstreamSize));
  
    getEventDispatcher().registerEvent(IBiDirQueuedNode::getUpstreamMaxSize_event, new TEDObject1<IBiDirQueuedNodeImpl, string, unsigned int(IBiDirQueuedNodeImpl:: * )(const string&) const, unsigned int >(this, &IBiDirQueuedNodeImpl::getUpstreamMaxSize));
  
    getEventDispatcher().registerEvent(IBiDirQueuedNode::getUpstreamMode_event, new TEDObject1<IBiDirQueuedNodeImpl, string, IQueued::Mode(IBiDirQueuedNodeImpl:: * )(const string&) const, IQueued::Mode >(this, &IBiDirQueuedNodeImpl::getUpstreamMode));
  
    getEventDispatcher().registerEvent(IBiDirQueuedNode::setUpstreamMaxSize_event, new TEDObject2<IBiDirQueuedNodeImpl, unsigned int, string, Result(IBiDirQueuedNodeImpl:: * )(const unsigned int&, const string&), Result >(this, &IBiDirQueuedNodeImpl::setUpstreamMaxSize));
    getEventDispatcher().addLimited(IBiDirQueuedNode::setUpstreamMaxSize_event, INode::CONSTRUCTED);
  
    getEventDispatcher().registerEvent(IBiDirQueuedNode::setUpstreamMode_event, new TEDObject2<IBiDirQueuedNodeImpl, IQueued::Mode, string, Result(IBiDirQueuedNodeImpl:: * )(const IQueued::Mode&, const string&), Result >(this, &IBiDirQueuedNodeImpl::setUpstreamMode));
    getEventDispatcher().addLimited(IBiDirQueuedNode::setUpstreamMode_event, INode::CONSTRUCTED);
  
    getEventDispatcher().registerEvent(IBiDirQueuedNode::setMaxSize_event, new TEDObject2<IBiDirQueuedNodeImpl, unsigned int, string, Result(IBiDirQueuedNodeImpl:: * )(const unsigned int&, const string&), Result >(this, &IBiDirQueuedNodeImpl::setMaxSize));
    getEventDispatcher().addLimited(IBiDirQueuedNode::setMaxSize_event, INode::CONSTRUCTED);
  
    getEventDispatcher().registerEvent(IBiDirQueuedNode::setMode_event, new TEDObject2<IBiDirQueuedNodeImpl, IQueued::Mode, string, Result(IBiDirQueuedNodeImpl:: * )(const IQueued::Mode&, const string&), Result >(this, &IBiDirQueuedNodeImpl::setMode));
    getEventDispatcher().addLimited(IBiDirQueuedNode::setMode_event, INode::CONSTRUCTED);

  }

}


