
#ifndef NMM_IUsageNotifyImpl_HPP
#define NMM_IUsageNotifyImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IUsageNotify.hpp"


namespace NMM
{
  /**
   *This Interfaces notifies the user about status-change
   */

  class IUsageNotifyImpl  : public virtual NMMObject { 
  public:
    IUsageNotifyImpl() { addInterface(new IUsageNotify(*this)); registerEvents(); };

    virtual ~IUsageNotifyImpl() {};

  protected:
    /**
     *If this function is called by the Usage-class, the user is the new master of the node
     */

    virtual Result becomeMaster() = 0;
    /**
     *If this function is called, the user has become slave on this node. This means, that an application with higher priority has requested the node
     */

    virtual Result becomeSlave() = 0;


  private:
    void registerEvents();
  };

}

#endif
