
#ifndef NMM_IMultiAudioSinkSynchronizerImpl_HPP
#define NMM_IMultiAudioSinkSynchronizerImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IMultiAudioSinkSynchronizer.hpp"

#include "ISinkSynchronizerImpl.hpp"

namespace NMM
{

  class IMultiAudioSinkSynchronizerImpl  : public virtual NMMObject { 
  public:
    IMultiAudioSinkSynchronizerImpl() { addInterface(new IMultiAudioSinkSynchronizer(*this)); registerEvents(); };

    virtual ~IMultiAudioSinkSynchronizerImpl() {};

  protected:
    /**
     * Adds an audio sink controller.
     * This adds the controller for an audio sink.
     * A new id is returned.
     * @param controller controller for this sink
     * @return id audio sink id
     */

    virtual int addAudioSinkController(const ISinkController* controller) = 0;


  private:
    void registerEvents();
  };

}

#endif
