
#ifndef NMM_ISourceSynchronizerImpl_HPP
#define NMM_ISourceSynchronizerImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "ISourceSynchronizer.hpp"

#include "ISynchronizerImpl.hpp"
#include "ISourceControllerImpl.hpp"

namespace NMM
{

  class ISourceSynchronizerImpl  : virtual public ISynchronizerImpl { 
  public:
    ISourceSynchronizerImpl() { addInterface(new ISourceSynchronizer(*this)); registerEvents(); };

    virtual ~ISourceSynchronizerImpl() {};

  protected:
    /**
     * Sets a skew between audio and video output.
     * The video output is presented later as the audio output.
     */

    virtual Result setMasterSkew(const Interval& skew) = 0;


  private:
    void registerEvents();
  };

}

#endif
