
#ifndef NMM_ISyncReset_HPP
#define NMM_ISyncReset_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class ISyncReset : virtual public Interface { 
  public:
    ISyncReset() {  setTypeInfo(TypeInfo(ISyncReset::ISyncReset_type, "NMM")); };

    ISyncReset(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(ISyncReset::ISyncReset_type, "NMM")); setEventReceiver(parent); };

    virtual ~ISyncReset() {};

    static const char* ISyncReset_type;

    virtual  string getInterfaceType() const { return ISyncReset_type; }

    Interface* copy() const { return new ISyncReset(*this); }
    static const char* syncReset_event;
    static Event* create_syncReset();
  /* instream (protected) and non-instream (public) */    
    virtual Result syncReset() /* in-stream */ 
      throw(const Exception&);


  };

  typedef auto_ptr<ISyncReset> ISyncReset_var;




}

#endif
