
#ifndef NMM_ISynchronizedSink_HPP
#define NMM_ISynchronizedSink_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>

#include "ISynchronized.hpp"
#include "ISinkController.hpp"

namespace NMM
{

  class ISynchronizedSink : virtual public ISynchronized { 
  public:
    ISynchronizedSink() {  setTypeInfo(TypeInfo(ISynchronizedSink::ISynchronizedSink_type, "NMM")); };

    ISynchronizedSink(NMMObject& parent) : ISynchronized(parent) {  setTypeInfo(TypeInfo(ISynchronizedSink::ISynchronizedSink_type, "NMM")); setEventReceiver(parent); };

    virtual ~ISynchronizedSink() {};

    static const char* ISynchronizedSink_type;

    virtual  string getInterfaceType() const { return ISynchronizedSink_type; }

    Interface* copy() const { return new ISynchronizedSink(*this); }
    static const char* getController_event;
    static const char* isBuffered_event;
    /**
     * Get the controller for this node.
     * The controller interface is needed by the synchronizer to communicate with the node.
     */

    virtual ISinkController* getController()
      throw(const Exception&);
    /**
     * Check if sink is a buffered sink.
     * Audio sinks for example are buffered sinks, video sinks are unbuffered.
     */

    virtual bool isBuffered() const
      throw(const Exception&);


  };

  typedef auto_ptr<ISynchronizedSink> ISynchronizedSink_var;




}

#endif
