
#ifndef NMM_IMultipleDevice_HPP
#define NMM_IMultipleDevice_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class IMultipleDevice : virtual public Interface { 
  public:
    IMultipleDevice() {  setTypeInfo(TypeInfo(IMultipleDevice::IMultipleDevice_type, "NMM")); };

    IMultipleDevice(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IMultipleDevice::IMultipleDevice_type, "NMM")); setEventReceiver(parent); };

    virtual ~IMultipleDevice() {};

    static const char* IMultipleDevice_type;

    virtual  string getInterfaceType() const { return IMultipleDevice_type; }

    Interface* copy() const { return new IMultipleDevice(*this); }
    static const char* setDevice_event;
    static const char* getDevice_event;

    virtual void setDevice(const string& name, const string& value)
      throw(const Exception&);

    virtual string getDevice(const string& name)
      throw(const Exception&);


  };

  typedef auto_ptr<IMultipleDevice> IMultipleDevice_var;




}

#endif
