
#ifndef NMM_ICDDBImpl_HPP
#define NMM_ICDDBImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "ICDDB.hpp"


namespace NMM
{

  class ICDDBImpl  : public virtual NMMObject { 
  public:
    ICDDBImpl() { addInterface(new ICDDB(*this)); registerEvents(); };

    virtual ~ICDDBImpl() {};

  protected:

    virtual Result setCDDBServer(const string& host, const int& port) = 0;

    virtual string getTrackName(const int& track) = 0;

    virtual string getDiscTitle() = 0;

    virtual string getDiscArtist() = 0;

    virtual void setCDDB(const bool& enabled) = 0;

    virtual bool getCDDB() = 0;


  private:
    void registerEvents();
  };

}

#endif
