
#include "IFileHandler.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IFileHandler::setFilename(const string& name)
      throw(const Exception&)
  {
    TInValue<string > name_value(name, false);
    Event event("IFileHandler::setFilename", &name_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* IFileHandler::IFileHandler_type = "IFileHandler";
  TIFactoryObject<IFileHandler > __IFileHandler_prototype("IFileHandler");


  const char* IFileHandler::setFilename_event = "IFileHandler::setFilename";


}


