
#ifndef NMM_IFileModeHandlerImpl_HPP
#define NMM_IFileModeHandlerImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IFileModeHandler.hpp"


namespace NMM
{

  class IFileModeHandlerImpl  : public virtual NMMObject { 
  public:
    IFileModeHandlerImpl() { addInterface(new IFileModeHandler(*this)); registerEvents(); };

    virtual ~IFileModeHandlerImpl() {};

  protected:

    virtual void setMode(const IFileModeHandler::FileMode& mode) = 0;

    virtual IFileModeHandler::FileMode getMode() = 0;

    virtual void setFormat(const IFileModeHandler::FileFormat& format) = 0;

    virtual IFileModeHandler::FileFormat getFormat() = 0;

    virtual void setFilenameMode(const IFileModeHandler::FilenameMode& mode) = 0;

    virtual IFileModeHandler::FilenameMode getFilenameMode() = 0;

    virtual void setLoop(const bool& d) = 0;


  private:
    void registerEvents();
  };

}

#endif
