
#include "IFileSize.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  bool IFileSize::hasFileSize()
      throw(const Exception&)
  {
    TOutValue<bool > return_value;
    Event event("IFileSize::hasFileSize");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  void IFileSize::getFileSize(u_int64_t& bytes)
      throw(const Exception&)
  {
    TOutValue<u_int64_t > bytes_value(bytes);
    Event event("IFileSize::getFileSize", &bytes_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    bytes = bytes_value.getRValue();
  }

  const char* IFileSize::IFileSize_type = "IFileSize";
  TIFactoryObject<IFileSize > __IFileSize_prototype("IFileSize");


  const char* IFileSize::hasFileSize_event = "IFileSize::hasFileSize";
  const char* IFileSize::getFileSize_event = "IFileSize::getFileSize";


}


