
#ifndef NMM_ISinkFileHandler_HPP
#define NMM_ISinkFileHandler_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>

#include "IFileHandler.hpp"
#include "ITrack.hpp"

namespace NMM
{

  class ISinkFileHandler : virtual public IFileHandler { 
  public:
    ISinkFileHandler() {  setTypeInfo(TypeInfo(ISinkFileHandler::ISinkFileHandler_type, "NMM")); };

    ISinkFileHandler(NMMObject& parent) : IFileHandler(parent) {  setTypeInfo(TypeInfo(ISinkFileHandler::ISinkFileHandler_type, "NMM")); setEventReceiver(parent); };

    virtual ~ISinkFileHandler() {};

    static const char* ISinkFileHandler_type;

    virtual  string getInterfaceType() const { return ISinkFileHandler_type; }

    Interface* copy() const { return new ISinkFileHandler(*this); }
    static const char* setWorkingDirectory_event;
    static const char* getWorkingDirectory_event;
    static const char* setFileExtension_event;
    static const char* getFileExtension_event;

    virtual void setWorkingDirectory(const string& directory)
      throw(const Exception&);

    virtual string getWorkingDirectory()
      throw(const Exception&);

    virtual void setFileExtension(const string& extension)
      throw(const Exception&);

    virtual string getFileExtension()
      throw(const Exception&);


  };

  typedef auto_ptr<ISinkFileHandler> ISinkFileHandler_var;




}

#endif
