
#ifndef NMM_IEncode_HPP
#define NMM_IEncode_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class IEncode : virtual public Interface { 
  public:
    IEncode() {  setTypeInfo(TypeInfo(IEncode::IEncode_type, "NMM")); };

    IEncode(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IEncode::IEncode_type, "NMM")); setEventReceiver(parent); };

    virtual ~IEncode() {};

    static const char* IEncode_type;

    virtual  string getInterfaceType() const { return IEncode_type; }

    Interface* copy() const { return new IEncode(*this); }
    static const char* setQuality_event;
    static const char* setBitrate_event;
    static const char* getQuality_event;
    static const char* getBitrate_event;

    virtual void setQuality(const float& quality)
      throw(const Exception&);

    virtual void setBitrate(const int& bitrate)
      throw(const Exception&);

    virtual float getQuality()
      throw(const Exception&);

    virtual int getBitrate()
      throw(const Exception&);


  };

  typedef auto_ptr<IEncode> IEncode_var;




}

#endif
