
#include "IProgressListener.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IProgressListener::setProgress(const u_int64_t& numerator, const u_int64_t& denominator) /* in-stream */ 
      throw(const Exception&)
  {
    TInValue<u_int64_t > numerator_value(numerator, false);
    TInValue<u_int64_t > denominator_value(denominator, false);
    Event event("IProgressListener::setProgress", &numerator_value, &denominator_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* IProgressListener::IProgressListener_type = "IProgressListener";
  TIFactoryObject<IProgressListener > __IProgressListener_prototype("IProgressListener");


  const char* IProgressListener::setProgress_event = "IProgressListener::setProgress";
  Event* IProgressListener::create_setProgress(const u_int64_t& numerator, const u_int64_t& denominator)
  {
    TInValue<u_int64_t >* numerator_value = new TInValue<u_int64_t >();
    numerator_value->setValue(numerator);
    TInValue<u_int64_t >* denominator_value = new TInValue<u_int64_t >();
    denominator_value->setValue(denominator);

    return new Event("IProgressListener::setProgress", numerator_value, denominator_value);
  }



}


