
#include "ITimeProgressListener.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void ITimeProgressListener::setTimeProgress(const Time& current_media_time) /* in-stream */ 
      throw(const Exception&)
  {
    TInValue<Time > current_media_time_value(current_media_time, false);
    Event event("ITimeProgressListener::setTimeProgress", &current_media_time_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* ITimeProgressListener::ITimeProgressListener_type = "ITimeProgressListener";
  TIFactoryObject<ITimeProgressListener > __ITimeProgressListener_prototype("ITimeProgressListener");


  const char* ITimeProgressListener::setTimeProgress_event = "ITimeProgressListener::setTimeProgress";
  Event* ITimeProgressListener::create_setTimeProgress(const Time& current_media_time)
  {
    TInValue<Time >* current_media_time_value = new TInValue<Time >();
    current_media_time_value->setValue(current_media_time);

    return new Event("ITimeProgressListener::setTimeProgress", current_media_time_value);
  }



}


