
#include "IDVBEPGPlugin.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IDVBEPGPlugin::setConfigFile(const string& f)
      throw(const Exception&)
  {
    TInValue<string > f_value(f, false);
    Event event("IDVBEPGPlugin::setConfigFile", &f_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  string IDVBEPGPlugin::getConfigFile()
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("IDVBEPGPlugin::getConfigFile");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  void IDVBEPGPlugin::setTVManager(const ITVManager* tvm)
      throw(const Exception&)
  {
    TInValue<ITVManager* > tvm_value (const_cast<ITVManager* >(tvm), false);
    Event event("IDVBEPGPlugin::setTVManager", &tvm_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* IDVBEPGPlugin::IDVBEPGPlugin_type = "IDVBEPGPlugin";
  TIFactoryObject<IDVBEPGPlugin > __IDVBEPGPlugin_prototype("IDVBEPGPlugin");


  const char* IDVBEPGPlugin::setConfigFile_event = "IDVBEPGPlugin::setConfigFile";
  const char* IDVBEPGPlugin::getConfigFile_event = "IDVBEPGPlugin::getConfigFile";
  const char* IDVBEPGPlugin::setTVManager_event = "IDVBEPGPlugin::setTVManager";


}


