
#include "INetServer.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void INetServer::setPort(const int& port)
      throw(const Exception&)
  {
    TInValue<int > port_value(port, false);
    Event event("INetServer::setPort", &port_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  int INetServer::getPort() const
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    Event event("INetServer::getPort");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  string INetServer::getHostName() const
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("INetServer::getHostName");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* INetServer::INetServer_type = "INetServer";
  TIFactoryObject<INetServer > __INetServer_prototype("INetServer");


  const char* INetServer::setPort_event = "INetServer::setPort";
  const char* INetServer::getPort_event = "INetServer::getPort";
  const char* INetServer::getHostName_event = "INetServer::getHostName";


}


