
#ifndef NMM_ITCPControlImpl_HPP
#define NMM_ITCPControlImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "ITCPControl.hpp"


namespace NMM
{

  class ITCPControlImpl  : public virtual NMMObject { 
  public:
    ITCPControlImpl() { addInterface(new ITCPControl(*this)); registerEvents(); };

    virtual ~ITCPControlImpl() {};

  protected:

    virtual void enableNoDelay(const bool& value) = 0;

    virtual bool isDelayEnabled() const = 0;

    virtual void setMaxSegment(const int& value) = 0;

    virtual int getMaxSegment() const = 0;

    virtual void enablePartialFrames(const bool& value) = 0;

    virtual bool isPartialFramesEnabled() = 0;

    virtual int getUnreadQueueCount() const = 0;

    virtual bool allUrgentDataSend() const = 0;

    virtual int getUnsendQueueCount() const = 0;

    virtual void enableKeepAlive(const bool& value) = 0;

    virtual bool getKeepAlive() const = 0;

    virtual void setRecvBufferSize(const int& value) = 0;

    virtual int getRecvBufferSize() const = 0;

    virtual void setSendBufferSize(const int& value) /* in-stream */  = 0;

    virtual int getSendBufferSize() const = 0;

    virtual void setPriority(const int& value) = 0;

    virtual int getPriority() const = 0;


  private:
    void registerEvents();
  };

}

#endif
