
#include "IBufferCounter.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  int IBufferCounter::getBuffersPassed() const
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    Event event("IBufferCounter::getBuffersPassed");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  void IBufferCounter::resetBufferCounter()
      throw(const Exception&)
  {
    Event event("IBufferCounter::resetBufferCounter");
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* IBufferCounter::IBufferCounter_type = "IBufferCounter";
  TIFactoryObject<IBufferCounter > __IBufferCounter_prototype("IBufferCounter");


  const char* IBufferCounter::getBuffersPassed_event = "IBufferCounter::getBuffersPassed";
  const char* IBufferCounter::resetBufferCounter_event = "IBufferCounter::resetBufferCounter";


}


