
#ifndef NMM_IBufferCounterImpl_HPP
#define NMM_IBufferCounterImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IBufferCounter.hpp"


namespace NMM
{
  /**
   * Interfae for counting the buffers processed by a node.
   */

  class IBufferCounterImpl  : public virtual NMMObject { 
  public:
    IBufferCounterImpl() { addInterface(new IBufferCounter(*this)); registerEvents(); };

    virtual ~IBufferCounterImpl() {};

  protected:
    /**
     * Get number of buffers processed.
     * Returns the current value of the buffer counter.
     */

    virtual int getBuffersPassed() const = 0;
    /**
     * Reset the buffer counter.
     * Resets the buffer counter to zero buffers processed.
     */

    virtual void resetBufferCounter() = 0;


  private:
    void registerEvents();
  };

}

#endif
