
#include "ISVGPaint.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void ISVGPaint::setImageHeight(const int& height)
      throw(const Exception&)
  {
    TInValue<int > height_value(height, false);
    Event event("ISVGPaint::setImageHeight", &height_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void ISVGPaint::setImageWidth(const int& width)
      throw(const Exception&)
  {
    TInValue<int > width_value(width, false);
    Event event("ISVGPaint::setImageWidth", &width_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void ISVGPaint::setShowSVGAnnotation(const bool& ssa)
      throw(const Exception&)
  {
    TInValue<bool > ssa_value(ssa, false);
    Event event("ISVGPaint::setShowSVGAnnotation", &ssa_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* ISVGPaint::ISVGPaint_type = "ISVGPaint";
  TIFactoryObject<ISVGPaint > __ISVGPaint_prototype("ISVGPaint");


  const char* ISVGPaint::setImageHeight_event = "ISVGPaint::setImageHeight";
  const char* ISVGPaint::setImageWidth_event = "ISVGPaint::setImageWidth";
  const char* ISVGPaint::setShowSVGAnnotation_event = "ISVGPaint::setShowSVGAnnotation";


}


