
#ifndef NMM_IScaler_HPP
#define NMM_IScaler_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class IScaler : virtual public Interface { 
  public:
    IScaler() {  setTypeInfo(TypeInfo(IScaler::IScaler_type, "NMM")); };

    IScaler(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IScaler::IScaler_type, "NMM")); setEventReceiver(parent); };

    virtual ~IScaler() {};

    static const char* IScaler_type;

    virtual  string getInterfaceType() const { return IScaler_type; }

    Interface* copy() const { return new IScaler(*this); }
    static const char* setAutoAspect_event;
    static const char* setFiltering_event;
    static const char* setOutputSize_event;
    static const char* getOutputSize_event;
    static const char* getAutoAspect_event;
    static const char* getFiltering_event;

    virtual void setAutoAspect(const bool& value)
      throw(const Exception&);

    virtual void setFiltering(const bool& value)
      throw(const Exception&);

    virtual void setOutputSize(const int& w, const int& h)
      throw(const Exception&);

    virtual void getOutputSize(int& w, int& h) const
      throw(const Exception&);

    virtual bool getAutoAspect() const
      throw(const Exception&);

    virtual bool getFiltering() const
      throw(const Exception&);


  };

  typedef auto_ptr<IScaler> IScaler_var;




}

#endif
