
#include "ICamera.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void ICamera::setBrightness(const int& value)
      throw(const Exception&)
  {
    TInValue<int > value_value(value, false);
    Event event("ICamera::setBrightness", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void ICamera::setAutoExposure(const int& value)
      throw(const Exception&)
  {
    TInValue<int > value_value(value, false);
    Event event("ICamera::setAutoExposure", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void ICamera::setSharpness(const int& value)
      throw(const Exception&)
  {
    TInValue<int > value_value(value, false);
    Event event("ICamera::setSharpness", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void ICamera::setWhiteBalance(const int& value)
      throw(const Exception&)
  {
    TInValue<int > value_value(value, false);
    Event event("ICamera::setWhiteBalance", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void ICamera::setBlueBalance(const int& value)
      throw(const Exception&)
  {
    TInValue<int > value_value(value, false);
    Event event("ICamera::setBlueBalance", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void ICamera::setRedBalance(const int& value)
      throw(const Exception&)
  {
    TInValue<int > value_value(value, false);
    Event event("ICamera::setRedBalance", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void ICamera::setHue(const int& value)
      throw(const Exception&)
  {
    TInValue<int > value_value(value, false);
    Event event("ICamera::setHue", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void ICamera::setSaturation(const int& value)
      throw(const Exception&)
  {
    TInValue<int > value_value(value, false);
    Event event("ICamera::setSaturation", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void ICamera::setGamma(const int& value)
      throw(const Exception&)
  {
    TInValue<int > value_value(value, false);
    Event event("ICamera::setGamma", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void ICamera::setShutter(const int& value)
      throw(const Exception&)
  {
    TInValue<int > value_value(value, false);
    Event event("ICamera::setShutter", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void ICamera::setGain(const int& value)
      throw(const Exception&)
  {
    TInValue<int > value_value(value, false);
    Event event("ICamera::setGain", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void ICamera::setIris(const int& value)
      throw(const Exception&)
  {
    TInValue<int > value_value(value, false);
    Event event("ICamera::setIris", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void ICamera::setFocus(const int& value)
      throw(const Exception&)
  {
    TInValue<int > value_value(value, false);
    Event event("ICamera::setFocus", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void ICamera::setZoom(const int& value)
      throw(const Exception&)
  {
    TInValue<int > value_value(value, false);
    Event event("ICamera::setZoom", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void ICamera::onePush()
      throw(const Exception&)
  {
    Event event("ICamera::onePush");
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  int ICamera::getBrightness() const
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    Event event("ICamera::getBrightness");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  int ICamera::getAutoExposure() const
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    Event event("ICamera::getAutoExposure");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  int ICamera::getSharpness() const
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    Event event("ICamera::getSharpness");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  int ICamera::getWhiteBalance() const
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    Event event("ICamera::getWhiteBalance");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  int ICamera::getBlueBalance() const
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    Event event("ICamera::getBlueBalance");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  int ICamera::getRedBalance() const
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    Event event("ICamera::getRedBalance");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  int ICamera::getHue() const
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    Event event("ICamera::getHue");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  int ICamera::getSaturation() const
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    Event event("ICamera::getSaturation");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  int ICamera::getGamma() const
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    Event event("ICamera::getGamma");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  int ICamera::getShutter() const
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    Event event("ICamera::getShutter");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  int ICamera::getGain() const
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    Event event("ICamera::getGain");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  int ICamera::getIris() const
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    Event event("ICamera::getIris");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  int ICamera::getFocus() const
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    Event event("ICamera::getFocus");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  int ICamera::getZoom() const
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    Event event("ICamera::getZoom");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  pair<int, int >  ICamera::getBrightnessRange() const
      throw(const Exception&)
  {
    TOutValue<pair<int, int >  > return_value;
    Event event("ICamera::getBrightnessRange");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  pair<int, int >  ICamera::getAutoExposureRange() const
      throw(const Exception&)
  {
    TOutValue<pair<int, int >  > return_value;
    Event event("ICamera::getAutoExposureRange");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  pair<int, int >  ICamera::getSharpnessRange() const
      throw(const Exception&)
  {
    TOutValue<pair<int, int >  > return_value;
    Event event("ICamera::getSharpnessRange");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  pair<int, int >  ICamera::getWhiteBalanceRange() const
      throw(const Exception&)
  {
    TOutValue<pair<int, int >  > return_value;
    Event event("ICamera::getWhiteBalanceRange");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  pair<int, int >  ICamera::getHueRange() const
      throw(const Exception&)
  {
    TOutValue<pair<int, int >  > return_value;
    Event event("ICamera::getHueRange");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  pair<int, int >  ICamera::getSaturationRange() const
      throw(const Exception&)
  {
    TOutValue<pair<int, int >  > return_value;
    Event event("ICamera::getSaturationRange");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  pair<int, int >  ICamera::getGammaRange() const
      throw(const Exception&)
  {
    TOutValue<pair<int, int >  > return_value;
    Event event("ICamera::getGammaRange");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  pair<int, int >  ICamera::getShutterRange() const
      throw(const Exception&)
  {
    TOutValue<pair<int, int >  > return_value;
    Event event("ICamera::getShutterRange");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  pair<int, int >  ICamera::getGainRange() const
      throw(const Exception&)
  {
    TOutValue<pair<int, int >  > return_value;
    Event event("ICamera::getGainRange");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  pair<int, int >  ICamera::getIrisRange() const
      throw(const Exception&)
  {
    TOutValue<pair<int, int >  > return_value;
    Event event("ICamera::getIrisRange");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  pair<int, int >  ICamera::getFocusRange() const
      throw(const Exception&)
  {
    TOutValue<pair<int, int >  > return_value;
    Event event("ICamera::getFocusRange");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  pair<int, int >  ICamera::getZoomRange() const
      throw(const Exception&)
  {
    TOutValue<pair<int, int >  > return_value;
    Event event("ICamera::getZoomRange");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  bool ICamera::hasBrightness() const
      throw(const Exception&)
  {
    TOutValue<bool > return_value;
    Event event("ICamera::hasBrightness");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  bool ICamera::hasAutoExposure() const
      throw(const Exception&)
  {
    TOutValue<bool > return_value;
    Event event("ICamera::hasAutoExposure");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  bool ICamera::hasSharpness() const
      throw(const Exception&)
  {
    TOutValue<bool > return_value;
    Event event("ICamera::hasSharpness");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  bool ICamera::hasWhiteBalance() const
      throw(const Exception&)
  {
    TOutValue<bool > return_value;
    Event event("ICamera::hasWhiteBalance");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  bool ICamera::hasHue() const
      throw(const Exception&)
  {
    TOutValue<bool > return_value;
    Event event("ICamera::hasHue");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  bool ICamera::hasSaturation() const
      throw(const Exception&)
  {
    TOutValue<bool > return_value;
    Event event("ICamera::hasSaturation");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  bool ICamera::hasGamma() const
      throw(const Exception&)
  {
    TOutValue<bool > return_value;
    Event event("ICamera::hasGamma");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  bool ICamera::hasShutter() const
      throw(const Exception&)
  {
    TOutValue<bool > return_value;
    Event event("ICamera::hasShutter");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  bool ICamera::hasGain() const
      throw(const Exception&)
  {
    TOutValue<bool > return_value;
    Event event("ICamera::hasGain");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  bool ICamera::hasIris() const
      throw(const Exception&)
  {
    TOutValue<bool > return_value;
    Event event("ICamera::hasIris");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  bool ICamera::hasFocus() const
      throw(const Exception&)
  {
    TOutValue<bool > return_value;
    Event event("ICamera::hasFocus");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  bool ICamera::hasZoom() const
      throw(const Exception&)
  {
    TOutValue<bool > return_value;
    Event event("ICamera::hasZoom");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* ICamera::ICamera_type = "ICamera";
  TIFactoryObject<ICamera > __ICamera_prototype("ICamera");


  const char* ICamera::setBrightness_event = "ICamera::setBrightness";
  const char* ICamera::setAutoExposure_event = "ICamera::setAutoExposure";
  const char* ICamera::setSharpness_event = "ICamera::setSharpness";
  const char* ICamera::setWhiteBalance_event = "ICamera::setWhiteBalance";
  const char* ICamera::setBlueBalance_event = "ICamera::setBlueBalance";
  const char* ICamera::setRedBalance_event = "ICamera::setRedBalance";
  const char* ICamera::setHue_event = "ICamera::setHue";
  const char* ICamera::setSaturation_event = "ICamera::setSaturation";
  const char* ICamera::setGamma_event = "ICamera::setGamma";
  const char* ICamera::setShutter_event = "ICamera::setShutter";
  const char* ICamera::setGain_event = "ICamera::setGain";
  const char* ICamera::setIris_event = "ICamera::setIris";
  const char* ICamera::setFocus_event = "ICamera::setFocus";
  const char* ICamera::setZoom_event = "ICamera::setZoom";
  const char* ICamera::onePush_event = "ICamera::onePush";
  const char* ICamera::getBrightness_event = "ICamera::getBrightness";
  const char* ICamera::getAutoExposure_event = "ICamera::getAutoExposure";
  const char* ICamera::getSharpness_event = "ICamera::getSharpness";
  const char* ICamera::getWhiteBalance_event = "ICamera::getWhiteBalance";
  const char* ICamera::getBlueBalance_event = "ICamera::getBlueBalance";
  const char* ICamera::getRedBalance_event = "ICamera::getRedBalance";
  const char* ICamera::getHue_event = "ICamera::getHue";
  const char* ICamera::getSaturation_event = "ICamera::getSaturation";
  const char* ICamera::getGamma_event = "ICamera::getGamma";
  const char* ICamera::getShutter_event = "ICamera::getShutter";
  const char* ICamera::getGain_event = "ICamera::getGain";
  const char* ICamera::getIris_event = "ICamera::getIris";
  const char* ICamera::getFocus_event = "ICamera::getFocus";
  const char* ICamera::getZoom_event = "ICamera::getZoom";
  const char* ICamera::getBrightnessRange_event = "ICamera::getBrightnessRange";
  const char* ICamera::getAutoExposureRange_event = "ICamera::getAutoExposureRange";
  const char* ICamera::getSharpnessRange_event = "ICamera::getSharpnessRange";
  const char* ICamera::getWhiteBalanceRange_event = "ICamera::getWhiteBalanceRange";
  const char* ICamera::getHueRange_event = "ICamera::getHueRange";
  const char* ICamera::getSaturationRange_event = "ICamera::getSaturationRange";
  const char* ICamera::getGammaRange_event = "ICamera::getGammaRange";
  const char* ICamera::getShutterRange_event = "ICamera::getShutterRange";
  const char* ICamera::getGainRange_event = "ICamera::getGainRange";
  const char* ICamera::getIrisRange_event = "ICamera::getIrisRange";
  const char* ICamera::getFocusRange_event = "ICamera::getFocusRange";
  const char* ICamera::getZoomRange_event = "ICamera::getZoomRange";
  const char* ICamera::hasBrightness_event = "ICamera::hasBrightness";
  const char* ICamera::hasAutoExposure_event = "ICamera::hasAutoExposure";
  const char* ICamera::hasSharpness_event = "ICamera::hasSharpness";
  const char* ICamera::hasWhiteBalance_event = "ICamera::hasWhiteBalance";
  const char* ICamera::hasHue_event = "ICamera::hasHue";
  const char* ICamera::hasSaturation_event = "ICamera::hasSaturation";
  const char* ICamera::hasGamma_event = "ICamera::hasGamma";
  const char* ICamera::hasShutter_event = "ICamera::hasShutter";
  const char* ICamera::hasGain_event = "ICamera::hasGain";
  const char* ICamera::hasIris_event = "ICamera::hasIris";
  const char* ICamera::hasFocus_event = "ICamera::hasFocus";
  const char* ICamera::hasZoom_event = "ICamera::hasZoom";


}


