
#include "IXDisplayEventSender.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IXDisplayEventSender::setSendingMouseEventsDirect(const bool& smed) /* limited(INode::STARTED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<bool > smed_value(smed, false);
    Event event("IXDisplayEventSender::setSendingMouseEventsDirect", &smed_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }
  
  bool IXDisplayEventSender::isSendingMouseEventsDirect()
      throw(const Exception&)
  {
    TOutValue<bool > return_value;
    Event event("IXDisplayEventSender::isSendingMouseEventsDirect");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  void IXDisplayEventSender::setUsingKeySymKeyEvents(const bool& ukke) /* limited(INode::STARTED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<bool > ukke_value(ukke, false);
    Event event("IXDisplayEventSender::setUsingKeySymKeyEvents", &ukke_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }
  
  bool IXDisplayEventSender::isUsingKeySymKeyEvents()
      throw(const Exception&)
  {
    TOutValue<bool > return_value;
    Event event("IXDisplayEventSender::isUsingKeySymKeyEvents");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  void IXDisplayEventSender::setXAutoRepeat(const bool& on)
      throw(const Exception&)
  {
    TInValue<bool > on_value(on, false);
    Event event("IXDisplayEventSender::setXAutoRepeat", &on_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  bool IXDisplayEventSender::isXAutoRepeat()
      throw(const Exception&)
  {
    TOutValue<bool > return_value;
    Event event("IXDisplayEventSender::isXAutoRepeat");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* IXDisplayEventSender::IXDisplayEventSender_type = "IXDisplayEventSender";
  TIFactoryObject<IXDisplayEventSender > __IXDisplayEventSender_prototype("IXDisplayEventSender");


  const char* IXDisplayEventSender::setSendingMouseEventsDirect_event = "IXDisplayEventSender::setSendingMouseEventsDirect";
  const char* IXDisplayEventSender::isSendingMouseEventsDirect_event = "IXDisplayEventSender::isSendingMouseEventsDirect";
  const char* IXDisplayEventSender::setUsingKeySymKeyEvents_event = "IXDisplayEventSender::setUsingKeySymKeyEvents";
  const char* IXDisplayEventSender::isUsingKeySymKeyEvents_event = "IXDisplayEventSender::isUsingKeySymKeyEvents";
  const char* IXDisplayEventSender::setXAutoRepeat_event = "IXDisplayEventSender::setXAutoRepeat";
  const char* IXDisplayEventSender::isXAutoRepeat_event = "IXDisplayEventSender::isXAutoRepeat";


}


