
#ifndef NMM_IXDisplayEventSenderImpl_HPP
#define NMM_IXDisplayEventSenderImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IXDisplayEventSender.hpp"

#include "nmm/interfaces/video/display/IDisplayEventSenderImpl.hpp"

namespace NMM
{
  /**
   * XDisplay event sender.
   * This Node extends IDisplayEventSender with methods to determine the kind mouseevents and keyevents are treated resp. to test,
   * which kind is choosen.
   */

  class IXDisplayEventSenderImpl  : virtual public IDisplayEventSenderImpl { 
  public:
    IXDisplayEventSenderImpl() { addInterface(new IXDisplayEventSender(*this)); registerEvents(); };

    virtual ~IXDisplayEventSenderImpl() {};

  protected:
    /**
     * Switches between processing only Mouseclicks, which are in predefined Screenrectangles or sending all MouseEvents.
     * @param smed boolean Value
     */

    virtual void setSendingMouseEventsDirect(const bool& smed) /* limited(INode::STARTED) */ = 0;
    /**
     * Returns Value of SendingMouseEventsDirect.
     */

    virtual bool isSendingMouseEventsDirect() = 0;
    /**
     * Switches between sending KeyEvents with strings or with KeySym representing the key triggering the event.
     * @param ukke boolean Value
     */

    virtual void setUsingKeySymKeyEvents(const bool& ukke) /* limited(INode::STARTED) */ = 0;
    /**
     * Returns Value of boolean Variable UsingKeySymKeyEvents.
     */

    virtual bool isUsingKeySymKeyEvents() = 0;
    /**
     * Turn XAutoRepeat on or off
     */

    virtual void setXAutoRepeat(const bool& on) = 0;
    /**
     * Is XAutoRepeat on or off?
     */

    virtual bool isXAutoRepeat() = 0;


  private:
    void registerEvents();
  };

}

#endif
