
#ifndef NMM_ITextDisplay_HPP
#define NMM_ITextDisplay_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>

#include "ISetOffset.hpp"

namespace NMM
{

  class ITextDisplay : virtual public ISetOffset { 
  public:
    ITextDisplay() {  setTypeInfo(TypeInfo(ITextDisplay::ITextDisplay_type, "NMM")); };

    ITextDisplay(NMMObject& parent) : ISetOffset(parent) {  setTypeInfo(TypeInfo(ITextDisplay::ITextDisplay_type, "NMM")); setEventReceiver(parent); };

    virtual ~ITextDisplay() {};

    static const char* ITextDisplay_type;

    virtual  string getInterfaceType() const { return ITextDisplay_type; }

    Interface* copy() const { return new ITextDisplay(*this); }
    static const char* setFontImage_event;

    virtual void setFontImage(const string& path)
      throw(const Exception&);


  };

  typedef auto_ptr<ITextDisplay> ITextDisplay_var;




}

#endif
