
#ifndef NMM_IMPEGVideoEncoder_HPP
#define NMM_IMPEGVideoEncoder_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class IMPEGVideoEncoder : virtual public Interface { 
  public:
    IMPEGVideoEncoder() {  setTypeInfo(TypeInfo(IMPEGVideoEncoder::IMPEGVideoEncoder_type, "NMM")); };

    IMPEGVideoEncoder(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IMPEGVideoEncoder::IMPEGVideoEncoder_type, "NMM")); setEventReceiver(parent); };

    virtual ~IMPEGVideoEncoder() {};

    static const char* IMPEGVideoEncoder_type;

    virtual  string getInterfaceType() const { return IMPEGVideoEncoder_type; }

    Interface* copy() const { return new IMPEGVideoEncoder(*this); }
    static const char* setMPEGVersion_event;
    static const char* setEncodingThreadCount_event;

    virtual void setMPEGVersion(const unsigned int& version)
      throw(const Exception&);

    virtual void setEncodingThreadCount(const unsigned int& number)
      throw(const Exception&);


  };

  typedef auto_ptr<IMPEGVideoEncoder> IMPEGVideoEncoder_var;




}

#endif
