
#ifndef NMM_IOSDSetFontImpl_HPP
#define NMM_IOSDSetFontImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IOSDSetFont.hpp"


namespace NMM
{
  /**
   * OSD base interface.
   * Base for all OSD interfaces that export a setFont method.
   */

  class IOSDSetFontImpl  : public virtual NMMObject { 
  public:
    IOSDSetFontImpl() { addInterface(new IOSDSetFont(*this)); registerEvents(); };

    virtual ~IOSDSetFontImpl() {};

  protected:
    /**
     * sets the Font of all text items
     * @param font_name path to locate the font
     * @param font_factor size of the font
     */

    virtual Result setFont(const string& font_name, const float& font_factor) = 0;


  private:
    void registerEvents();
  };

}

#endif
