
#ifndef NMM_IBorderDecorator_HPP
#define NMM_IBorderDecorator_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>

#include "IDecorator.hpp"

namespace NMM
{
  /**
   * Border decorator interface.
   */

  class IBorderDecorator : virtual public IDecorator { 
  public:
    IBorderDecorator() {  setTypeInfo(TypeInfo(IBorderDecorator::IBorderDecorator_type, "NMM")); };

    IBorderDecorator(NMMObject& parent) : IDecorator(parent) {  setTypeInfo(TypeInfo(IBorderDecorator::IBorderDecorator_type, "NMM")); setEventReceiver(parent); };

    virtual ~IBorderDecorator() {};

    static const char* IBorderDecorator_type;

    virtual  string getInterfaceType() const { return IBorderDecorator_type; }

    Interface* copy() const { return new IBorderDecorator(*this); }
    static const char* setBorderWidth_event;
    static const char* setBorderColor_event;
    /**
     * Set border width.
     * @param bw border width
     */

    virtual void setBorderWidth(const unsigned int& bw)
      throw(const Exception&);
    /**
     * Set boder color.
     * @param color border color (rgba format)
     */

    virtual void setBorderColor(const u_int32_t& color)
      throw(const Exception&);


  };

  typedef auto_ptr<IBorderDecorator> IBorderDecorator_var;




}

#endif
