
#ifndef NMM_IBorderDecoratorImpl_HPP
#define NMM_IBorderDecoratorImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IBorderDecorator.hpp"

#include "IDecoratorImpl.hpp"

namespace NMM
{
  /**
   * Border decorator interface.
   */

  class IBorderDecoratorImpl  : virtual public IDecoratorImpl { 
  public:
    IBorderDecoratorImpl() { addInterface(new IBorderDecorator(*this)); registerEvents(); };

    virtual ~IBorderDecoratorImpl() {};

  protected:
    /**
     * Set border width.
     * @param bw border width
     */

    virtual void setBorderWidth(const unsigned int& bw) = 0;
    /**
     * Set boder color.
     * @param color border color (rgba format)
     */

    virtual void setBorderColor(const u_int32_t& color) = 0;


  private:
    void registerEvents();
  };

}

#endif
