
#include "IDecorator.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  IWidget* IDecorator::getInternalWidget() const
      throw(const Exception&)
  {
    TOutValue<IWidget* > return_value;
    Event event("IDecorator::getInternalWidget");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  void IDecorator::setInternalWidget(const IWidget& widget)
      throw(const Exception&)
  {
    TInValue<IWidget > widget_value(widget, false);
    Event event("IDecorator::setInternalWidget", &widget_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* IDecorator::IDecorator_type = "IDecorator";
  TIFactoryObject<IDecorator > __IDecorator_prototype("IDecorator");


  const char* IDecorator::getInternalWidget_event = "IDecorator::getInternalWidget";
  const char* IDecorator::setInternalWidget_event = "IDecorator::setInternalWidget";


}


