
#ifndef NMM_IDecorator_HPP
#define NMM_IDecorator_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>

#include "IWidget.hpp"

namespace NMM
{
  /**
   * Decorator interface.
   */

  class IDecorator : virtual public IWidget { 
  public:
    IDecorator() {  setTypeInfo(TypeInfo(IDecorator::IDecorator_type, "NMM")); };

    IDecorator(NMMObject& parent) : IWidget(parent) {  setTypeInfo(TypeInfo(IDecorator::IDecorator_type, "NMM")); setEventReceiver(parent); };

    virtual ~IDecorator() {};

    static const char* IDecorator_type;

    virtual  string getInterfaceType() const { return IDecorator_type; }

    Interface* copy() const { return new IDecorator(*this); }
    static const char* getInternalWidget_event;
    static const char* setInternalWidget_event;
    /** Get internal widget. */

    virtual IWidget* getInternalWidget() const
      throw(const Exception&);
    /** Set internal widget. */

    virtual void setInternalWidget(const IWidget& widget)
      throw(const Exception&);


  };

  typedef auto_ptr<IDecorator> IDecorator_var;




}

#endif
