
#include "IScrollDecorator.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IScrollDecorator::setBarWidth(const unsigned int& bw)
      throw(const Exception&)
  {
    TInValue<unsigned int > bw_value(bw, false);
    Event event("IScrollDecorator::setBarWidth", &bw_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void IScrollDecorator::setBackgroundColor(const u_int32_t& bcolor)
      throw(const Exception&)
  {
    TInValue<u_int32_t > bcolor_value(bcolor, false);
    Event event("IScrollDecorator::setBackgroundColor", &bcolor_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void IScrollDecorator::setBorderColor(const u_int32_t& bcolor)
      throw(const Exception&)
  {
    TInValue<u_int32_t > bcolor_value(bcolor, false);
    Event event("IScrollDecorator::setBorderColor", &bcolor_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void IScrollDecorator::setBarColor(const u_int32_t& bcolor)
      throw(const Exception&)
  {
    TInValue<u_int32_t > bcolor_value(bcolor, false);
    Event event("IScrollDecorator::setBarColor", &bcolor_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void IScrollDecorator::setBarBorderColors(const u_int32_t& bcolor1, const u_int32_t& bcolor2)
      throw(const Exception&)
  {
    TInValue<u_int32_t > bcolor1_value(bcolor1, false);
    TInValue<u_int32_t > bcolor2_value(bcolor2, false);
    Event event("IScrollDecorator::setBarBorderColors", &bcolor1_value, &bcolor2_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* IScrollDecorator::IScrollDecorator_type = "IScrollDecorator";
  TIFactoryObject<IScrollDecorator > __IScrollDecorator_prototype("IScrollDecorator");


  const char* IScrollDecorator::setBarWidth_event = "IScrollDecorator::setBarWidth";
  const char* IScrollDecorator::setBackgroundColor_event = "IScrollDecorator::setBackgroundColor";
  const char* IScrollDecorator::setBorderColor_event = "IScrollDecorator::setBorderColor";
  const char* IScrollDecorator::setBarColor_event = "IScrollDecorator::setBarColor";
  const char* IScrollDecorator::setBarBorderColors_event = "IScrollDecorator::setBarBorderColors";


}


