
#ifndef NMM_IScrollDecoratorImpl_HPP
#define NMM_IScrollDecoratorImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IScrollDecorator.hpp"

#include "IDecoratorImpl.hpp"

namespace NMM
{
  /**
   * Scroll decorator interface.
   */

  class IScrollDecoratorImpl  : virtual public IDecoratorImpl { 
  public:
    IScrollDecoratorImpl() { addInterface(new IScrollDecorator(*this)); registerEvents(); };

    virtual ~IScrollDecoratorImpl() {};

  protected:

    virtual void setBarWidth(const unsigned int& bw) = 0;

    virtual void setBackgroundColor(const u_int32_t& bcolor) = 0;

    virtual void setBorderColor(const u_int32_t& bcolor) = 0;

    virtual void setBarColor(const u_int32_t& bcolor) = 0;

    virtual void setBarBorderColors(const u_int32_t& bcolor1, const u_int32_t& bcolor2) = 0;


  private:
    void registerEvents();
  };

}

#endif
