
#include "ITextViewImpl.hpp"


namespace NMM
{
  
  void ITextViewImpl::registerEvents()
  {
  
    getEventDispatcher().registerEvent(ITextView::setFont_event, new TEDObject1<ITextViewImpl, string, void(ITextViewImpl:: * )(const string&), void >(this, &ITextViewImpl::setFont));
  
    getEventDispatcher().registerEvent(ITextView::selectLine_event, new TEDObject1<ITextViewImpl, unsigned int, unsigned int(ITextViewImpl:: * )(const unsigned int&), unsigned int >(this, &ITextViewImpl::selectLine));
  
    getEventDispatcher().registerEvent(ITextView::selectLine2_event, new TEDObject1<ITextViewImpl, unsigned int, unsigned int(ITextViewImpl:: * )(const unsigned int&), unsigned int >(this, &ITextViewImpl::selectLine2));
  
    getEventDispatcher().registerEvent(ITextView::deSelectLine_event, new TEDObject0<ITextViewImpl, void(ITextViewImpl:: * )(), void >(this, &ITextViewImpl::deSelectLine));
  
    getEventDispatcher().registerEvent(ITextView::deSelectLine2_event, new TEDObject0<ITextViewImpl, void(ITextViewImpl:: * )(), void >(this, &ITextViewImpl::deSelectLine2));
  
    getEventDispatcher().registerEvent(ITextView::getSelectedLine_event, new TEDObject0<ITextViewImpl, unsigned int(ITextViewImpl:: * )() const, unsigned int >(this, &ITextViewImpl::getSelectedLine));
  
    getEventDispatcher().registerEvent(ITextView::getSelectedLine2_event, new TEDObject0<ITextViewImpl, unsigned int(ITextViewImpl:: * )() const, unsigned int >(this, &ITextViewImpl::getSelectedLine2));
  
    getEventDispatcher().registerEvent(ITextView::getLineContent_event, new TEDObject1<ITextViewImpl, unsigned int, string(ITextViewImpl:: * )(const unsigned int&) const, string >(this, &ITextViewImpl::getLineContent));
  
    getEventDispatcher().registerEvent(ITextView::changeLineContent_event, new TEDObject2<ITextViewImpl, unsigned int, string, void(ITextViewImpl:: * )(const unsigned int&, const string&), void >(this, &ITextViewImpl::changeLineContent));
  
    getEventDispatcher().registerEvent(ITextView::getLineURL_event, new TEDObject1<ITextViewImpl, unsigned int, string(ITextViewImpl:: * )(const unsigned int&) const, string >(this, &ITextViewImpl::getLineURL));
  
    getEventDispatcher().registerEvent(ITextView::getLineWidget_event, new TEDObject1<ITextViewImpl, unsigned int, IWidget*(ITextViewImpl:: * )(const unsigned int&) const, IWidget* >(this, &ITextViewImpl::getLineWidget));
  
    getEventDispatcher().registerEvent(ITextView::setAutoFocus_event, new TEDObject1<ITextViewImpl, bool, void(ITextViewImpl:: * )(const bool&), void >(this, &ITextViewImpl::setAutoFocus));
  
    getEventDispatcher().registerEvent(ITextView::setSelectionColor_event, new TEDObject1<ITextViewImpl, u_int32_t, void(ITextViewImpl:: * )(const u_int32_t&), void >(this, &ITextViewImpl::setSelectionColor));
  
    getEventDispatcher().registerEvent(ITextView::setSelectionColor2_event, new TEDObject1<ITextViewImpl, u_int32_t, void(ITextViewImpl:: * )(const u_int32_t&), void >(this, &ITextViewImpl::setSelectionColor2));
  
    getEventDispatcher().registerEvent(ITextView::reset_event, new TEDObject0<ITextViewImpl, void(ITextViewImpl:: * )(), void >(this, &ITextViewImpl::reset));
  
    getEventDispatcher().registerEvent(ITextView::setMaxLines_event, new TEDObject1<ITextViewImpl, unsigned int, void(ITextViewImpl:: * )(const unsigned int&), void >(this, &ITextViewImpl::setMaxLines));
  
    getEventDispatcher().registerEvent(ITextView::getMaxLines_event, new TEDObject0<ITextViewImpl, unsigned int(ITextViewImpl:: * )() const, unsigned int >(this, &ITextViewImpl::getMaxLines));
  
    getEventDispatcher().registerEvent(ITextView::setStartLine_event, new TEDObject1<ITextViewImpl, unsigned int, unsigned int(ITextViewImpl:: * )(const unsigned int&), unsigned int >(this, &ITextViewImpl::setStartLine));
  
    getEventDispatcher().registerEvent(ITextView::getStartLine_event, new TEDObject0<ITextViewImpl, unsigned int(ITextViewImpl:: * )() const, unsigned int >(this, &ITextViewImpl::getStartLine));
  
    getEventDispatcher().registerEvent(ITextView::getNumLines_event, new TEDObject0<ITextViewImpl, unsigned int(ITextViewImpl:: * )() const, unsigned int >(this, &ITextViewImpl::getNumLines));
  
    getEventDispatcher().registerEvent(ITextView::focusSelection_event, new TEDObject0<ITextViewImpl, void(ITextViewImpl:: * )(), void >(this, &ITextViewImpl::focusSelection));
  
    getEventDispatcher().registerEvent(ITextView::insertLine_event, new TEDObject3<ITextViewImpl, int, string, string, void(ITextViewImpl:: * )(const int&, const string&, const string&), void >(this, &ITextViewImpl::insertLine));
  
    getEventDispatcher().registerEvent(ITextView::addLine_event, new TEDObject2<ITextViewImpl, string, string, int(ITextViewImpl:: * )(const string&, const string&), int >(this, &ITextViewImpl::addLine));
  
    getEventDispatcher().registerEvent(ITextView::addLineWidget_event, new TEDObject2<ITextViewImpl, unsigned int, IWidget, void(ITextViewImpl:: * )(const unsigned int&, const IWidget&), void >(this, &ITextViewImpl::addLineWidget));
  
    getEventDispatcher().registerEvent(ITextView::deleteLine_event, new TEDObject1<ITextViewImpl, unsigned int, void(ITextViewImpl:: * )(const unsigned int&), void >(this, &ITextViewImpl::deleteLine));
  
    getEventDispatcher().registerEvent(ITextView::deleteAllLines_event, new TEDObject0<ITextViewImpl, void(ITextViewImpl:: * )(), void >(this, &ITextViewImpl::deleteAllLines));
  
    getEventDispatcher().registerEvent(ITextView::markLine_event, new TEDObject1<ITextViewImpl, unsigned int, void(ITextViewImpl:: * )(const unsigned int&), void >(this, &ITextViewImpl::markLine));
  
    getEventDispatcher().registerEvent(ITextView::unmarkLine_event, new TEDObject1<ITextViewImpl, unsigned int, void(ITextViewImpl:: * )(const unsigned int&), void >(this, &ITextViewImpl::unmarkLine));
  
    getEventDispatcher().registerEvent(ITextView::getMarkedLines_event, new TEDObject0<ITextViewImpl, list<unsigned int > (ITextViewImpl:: * )(), list<unsigned int >  >(this, &ITextViewImpl::getMarkedLines));

  }

}


