
#ifndef NMM_ITimeViewImpl_HPP
#define NMM_ITimeViewImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "ITimeView.hpp"

#include "IWidgetImpl.hpp"

namespace NMM
{
  /**
   * Time view widget interface.
   */

  class ITimeViewImpl  : virtual public IWidgetImpl { 
  public:
    ITimeViewImpl() { addInterface(new ITimeView(*this)); registerEvents(); };

    virtual ~ITimeViewImpl() {};

  protected:
    /**
     * Set font.
     * Set the font that is used to draw the text.
     * @param value font name
     */

    virtual void setFont(const string& value) = 0;
    /**
     * Set prefix text.
     * Set prefix text that is placed in front of the time.
     * @param value prefix text
     */

    virtual void setPrefix(const string& value) = 0;
    /** Sets time offset. */

    virtual void setTimeOffset(const int& value) = 0;
    /** Set current time. */

    virtual void setCurrentTime(const int& value) = 0;
    /** Get current time. */

    virtual int getCurrentTime() = 0;
    /** Resets timer. */

    virtual void reset() = 0;


  private:
    void registerEvents();
  };

}

#endif
