
#include "IIVTV.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  IVTVCodec IIVTV::getCodecParams() const /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<IVTVCodec > return_value;
    Event event("IIVTV::getCodecParams");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  void IIVTV::setCodecParams(const IVTVCodec& codec) /* limited(INode::INITIALIZED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<IVTVCodec > codec_value(codec, false);
    Event event("IIVTV::setCodecParams", &codec_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }
  
  void IIVTV::setGOPSize(const unsigned int& value) /* limited(INode::INITIALIZED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<unsigned int > value_value(value, false);
    Event event("IIVTV::setGOPSize", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }
  
  void IIVTV::setBFrames(const unsigned int& value) /* limited(INode::INITIALIZED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<unsigned int > value_value(value, false);
    Event event("IIVTV::setBFrames", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }
  
  void IIVTV::setGOPClosure(const unsigned int& value) /* limited(INode::INITIALIZED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<unsigned int > value_value(value, false);
    Event event("IIVTV::setGOPClosure", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }
  
  void IIVTV::setPulldown(const unsigned int& value) /* limited(INode::INITIALIZED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<unsigned int > value_value(value, false);
    Event event("IIVTV::setPulldown", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }
  
  void IIVTV::setBitrate(const unsigned int& value) /* limited(INode::INITIALIZED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<unsigned int > value_value(value, false);
    Event event("IIVTV::setBitrate", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }
  
  void IIVTV::setPeakBitrate(const unsigned int& value) /* limited(INode::INITIALIZED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<unsigned int > value_value(value, false);
    Event event("IIVTV::setPeakBitrate", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }
  
  void IIVTV::setStreamType(const unsigned int& value) /* limited(INode::INITIALIZED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<unsigned int > value_value(value, false);
    Event event("IIVTV::setStreamType", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }
  
  void IIVTV::setBitrateMode(const unsigned int& value) /* limited(INode::INITIALIZED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<unsigned int > value_value(value, false);
    Event event("IIVTV::setBitrateMode", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }
  
  void IIVTV::setDNRMode(const unsigned int& value) /* limited(INode::INITIALIZED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<unsigned int > value_value(value, false);
    Event event("IIVTV::setDNRMode", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }
  
  void IIVTV::setDNRType(const unsigned int& value) /* limited(INode::INITIALIZED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<unsigned int > value_value(value, false);
    Event event("IIVTV::setDNRType", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }
  
  void IIVTV::setDNRSpatial(const unsigned int& value) /* limited(INode::INITIALIZED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<unsigned int > value_value(value, false);
    Event event("IIVTV::setDNRSpatial", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }
  
  void IIVTV::setDNRTemporal(const unsigned int& value) /* limited(INode::INITIALIZED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<unsigned int > value_value(value, false);
    Event event("IIVTV::setDNRTemporal", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }
  
  void IIVTV::setAspect(const unsigned int& value) /* limited(INode::INITIALIZED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<unsigned int > value_value(value, false);
    Event event("IIVTV::setAspect", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }

  const char* IIVTV::IIVTV_type = "IIVTV";
  TIFactoryObject<IIVTV > __IIVTV_prototype("IIVTV");


  const char* IIVTV::getCodecParams_event = "IIVTV::getCodecParams";
  const char* IIVTV::setCodecParams_event = "IIVTV::setCodecParams";
  const char* IIVTV::setGOPSize_event = "IIVTV::setGOPSize";
  const char* IIVTV::setBFrames_event = "IIVTV::setBFrames";
  const char* IIVTV::setGOPClosure_event = "IIVTV::setGOPClosure";
  const char* IIVTV::setPulldown_event = "IIVTV::setPulldown";
  const char* IIVTV::setBitrate_event = "IIVTV::setBitrate";
  const char* IIVTV::setPeakBitrate_event = "IIVTV::setPeakBitrate";
  const char* IIVTV::setStreamType_event = "IIVTV::setStreamType";
  const char* IIVTV::setBitrateMode_event = "IIVTV::setBitrateMode";
  const char* IIVTV::setDNRMode_event = "IIVTV::setDNRMode";
  const char* IIVTV::setDNRType_event = "IIVTV::setDNRType";
  const char* IIVTV::setDNRSpatial_event = "IIVTV::setDNRSpatial";
  const char* IIVTV::setDNRTemporal_event = "IIVTV::setDNRTemporal";
  const char* IIVTV::setAspect_event = "IIVTV::setAspect";


}


