; Copyright (C) 1993-2002 Silicon Graphics, Inc. All
;
; Maintainer:  
;
; This code was taken from the developer corner (Optimizing
; CPU to Memory Accesses) of SGI
; I adjusted this code to handle input parameters and to
; work fine with nasm compiler

; this function uses mmx and prefetch capabilities to do
; a fast memory copy on Pentium (>=III) CPUs

global fastmemcpy:function			;must be declared for linker (ld)
; void fastmemcpy( void* dest, void* src, unsigned int bytenum, void* tbuf );
; note: bytenum must be a multiple of 2048

section	.text

fastmemcpy:		       ; tell linker entry point
	push      ebp
 	mov       ebp,esp
	push      ebx
	push      esi
	push      edi

        mov esi, [ebp+12]	; pointer to src
        mov ecx, [ebp+16]	; nbytes
        mov ebx, ecx
        shr ebx, 11 	        ; 2048 bytes at a time
        mov edi, [ebp+8]	; pointer to dest

_loop2k: 			; Copy 2k into temporary buffer
	push edi
        mov edi, [ebp+20]	; pointer to temporary buffer
        mov ecx, 2048
        shr ecx, 6

_loopMemToL1:
        prefetchnta [ESI+64]	; Prefetch next loop, non-temporal
        prefetchnta [ESI+96]

        movq mm1, [ESI+0]	; Read in source data
        movq mm2, [ESI+8]
        movq mm3, [ESI+16]
        movq mm4, [ESI+24]
        movq mm5, [ESI+32]
        movq mm6, [ESI+40]
        movq mm7, [ESI+48]
        movq mm0, [ESI+56]

        movq [EDI+0],  mm1	; Store into L1
        movq [EDI+8],  mm2
        movq [EDI+16], mm3
        movq [EDI+24], mm4
        movq [EDI+32], mm5
        movq [EDI+40], mm6
        movq [EDI+48], mm7
        movq [EDI+56], mm0
        add esi, 64
        add edi, 64
        dec ecx
        jnz NEAR _loopMemToL1

        pop edi			; Now copy from L1 to system memory
        push esi
        mov esi, [ebp+20]	; pointer to temporary buffer
        mov ecx, 2048
        shr ecx, 6

_loopL1ToMem:
	movq mm1, [ESI+0]	; Read in source data from L1
 	movq mm2, [ESI+8]
  	movq mm3, [ESI+16]
   	movq mm4, [ESI+24]
    	movq mm5, [ESI+32]
     	movq mm6, [ESI+40]
      	movq mm7, [ESI+48]
       	movq mm0, [ESI+56]

        movntq [EDI+0],  mm1	; Non-temporal stores
        movntq [EDI+8],  mm2
        movntq [EDI+16], mm3
        movntq [EDI+24], mm4
        movntq [EDI+32], mm5
        movntq [EDI+40], mm6
        movntq [EDI+48], mm7
        movntq [EDI+56], mm0

        add esi, 64
        add edi, 64
        dec ecx
        jnz NEAR _loopL1ToMem

        pop esi			; Do next 2k block
        dec ebx
        jnz NEAR _loop2k


_end:
	emms
        pop      edi
        pop      esi

        mov      ebx,[ebp-4]
        leave                  ; mov esp,ebp / pop ebp
        ret



