#define LCD_WRITE 10
#define LCD_CLEAR 20
#define LCD_WRITE_CHAR 30
#define LCD_DEC_USE_COUNT 40
#define CHARNUM_UP_ARROW 0x0
#define CHARNUM_DOWN_ARROW 0x1
#define CHARNUM_TRADEMARK_T 0x2
#define CHARNUM_TRADEMARK_M 0x3
#define CHARNUM_BAR1 0x4
#define CHARNUM_BAR2 0x5
#define CHARNUM_BAR3 0x6
#define CHARNUM_BAR4 0x7
#define CHARNUM_BAR5 0xff // can't write more than 8 user
// defined characters, and "all pixels on" was already defined as 0xff.

const unsigned char LCD_CHAR_BAR1[] = {
  0x10, // ---10000
  0x10, // ---10000
  0x10, // ---10000
  0x10, // ---10000
  0x10, // ---10000
  0x10, // ---10000
  0x10, // ---10000
  0x10  // ---10000
};

const unsigned char LCD_CHAR_BAR2[] = {
  0x18, // ---11000
  0x18, // ---11000
  0x18, // ---11000
  0x18, // ---11000
  0x18, // ---11000
  0x18, // ---11000
  0x18, // ---11000
  0x18  // ---11000
};

const unsigned char LCD_CHAR_BAR3[] = {
  0x1c, // ---11100
  0x1c, // ---11100
  0x1c, // ---11100
  0x1c, // ---11100
  0x1c, // ---11100
  0x1c, // ---11100
  0x1c, // ---11100
  0x1c  // ---11100
};

const unsigned char LCD_CHAR_BAR4[] = {
  0x1e, // ---11110
  0x1e, // ---11110
  0x1e, // ---11110
  0x1e, // ---11110
  0x1e, // ---11110
  0x1e, // ---11110
  0x1e, // ---11110
  0x1e  // ---11110
};

const unsigned char LCD_CHAR_BAR5[] = {
  0x1f, // ---11111
  0x1f, // ---11111
  0x1f, // ---11111
  0x1f, // ---11111
  0x1f, // ---11111
  0x1f, // ---11111
  0x1f, // ---11111
  0x1f  // ---11111
};

const unsigned char LCD_CHAR_UP_ARROW[] = {
  0x1f, // ---11111
  0x1b, // ---11011
  0x11, // ---10001
  0x0a, // ---01010
  0x1b, // ---11011
  0x1b, // ---11011
  0x1b, // ---11011
  0x1f  // ---11111
};

const unsigned char LCD_CHAR_DOWN_ARROW[] = {
  0x1f, // ---11111
  0x1b, // ---11011
  0x1b, // ---11011
  0x1b, // ---11011
  0x0a, // ---01010
  0x11, // ---10001
  0x1b, // ---11011
  0x1f  // ---11111
};

const unsigned char LCD_CHAR_TRADEMARK_T[] = {
  0x1f, // ---11111
  0x04, // ---00100
  0x04, // ---00100
  0x04, // ---00100
  0x00, // ---00000
  0x00, // ---00000
  0x00, // ---00000
  0x00  // ---00000
};

const unsigned char LCD_CHAR_TRADEMARK_M[] = {
  0x11, // ---10001
  0x1b, // ---11011
  0x15, // ---10101
  0x11, // ---10001
  0x00, // ---00000
  0x00, // ---00000
  0x00, // ---00000
  0x00  // ---00000
};

struct LCDctrl
{
  unsigned char line0[41];
  unsigned char line1[41];
  int posx;
  int posy;
  unsigned char ch;
};
