/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:         
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#ifndef _NMM_IRCONTROL_HPP_
#define _NMM_IRCONTROL_HPP_ _NMM_IRCONTROL_HPP_

#include <string>
#include <lirc/lirc_client.h>

using namespace std;


class IRControl {
private:
  bool initialized;
  string prog_name;
  int lirc_fd;
  string config_file;
  struct lirc_config* lirc_config;


public:
  enum IRKey {
    NOKEY,
    KEY1,KEY2,KEY3,KEY4,KEY5,KEY6,KEY7,KEY8,KEY9,KEY0,
    START,STOP,PAUSE,
    NEXT,PREVIOUS,FORWARD,REWIND,
    POWER};

  IRControl(string name = "nmmirc");
  ~IRControl();

  bool init(string config = "");

  IRKey getKey(int msec = 1000);
};

#endif //_NMM_IRCONTROL_HPP_
