#include "xmltvhelper.hpp"
#include "nmm/utils/xml/xml++.hpp"
#include "nmm/utils/utils.hpp"

namespace NMM{

  string transformToLocalTime(string s){
    try{
      
      time_t localTime = time(NULL);
      localtime(&localTime); //Just to be sure, that external time-variables of time.h are initialized

      time_t xmlTime = stringToTime(s);
      unsigned int pos = s.find_first_of(' ');
      int xmlDifference= 0;
      if(pos != string::npos){
        //if no timezone-info is available, assume UTC
        xmlDifference = atoi(s.substr(pos+1,5).c_str())/100;
      }
      char timeString[25];
      //Compute the difference between the xml-Timezone and our timezone and update the outputtime accordingly
      xmlTime +=  ((-1*timezone) - (xmlDifference*3600));
      double timeDifference = -1*timezone/60/60 * 100; //in hours
      strftime(timeString, sizeof(timeString), "%Y%m%d%H%M", localtime(&xmlTime));
      sprintf(timeString, "%s %0+5.0f", timeString, timeDifference);
      return string(timeString);
      
    }catch (...){
      return s;
    }    
  }
  
  string transformToISO8859(string s){
    XMLEncoder e("ISO-8859-1");
    string ret = e.getEncodedString(s);
    return ret;
  }//end transformSpecialCharsOut
  
}
