/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        Christian Gerstner <gerstner@graphics.cs.uni-sb.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#ifndef NMM_PCMDECODENODE_HPP
#define NMM_PCMDECODENODE_HPP NMM_PCMDECODENODE_HPP

#include "nmm/base/GenericProcessorNode.hpp"


namespace NMM {
  class PCMDecodeNode :
    public GenericProcessorNode
  {
    
  private:
    enum codec_type{PCMU, PCMA};
    codec_type codec;
    
  protected:
    

    virtual Result doInit();
    virtual Result doDeinit();
    virtual Result doInitOutput();
    virtual Message *processBuffer( Buffer *in_buffer);
    
   public:
    PCMDecodeNode( const char * = "PCMDecodeNode", StreamQueue::Mode = StreamQueue::MODE_SUSPEND, int = 20);
    virtual ~PCMDecodeNode();

  };

}

#endif //NMM_PCMDECODENODE_HPP

