/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        Christian Gerstner <gerstner@graphics.cs.uni-sb.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#ifndef NMM_PCMENCODENODE_HPP
#define NMM_PCMENCODENODE_HPP NMM_PCMENCODENODE_HPP

#include "nmm/base/GenericProcessorNode.hpp"

namespace NMM {

  class PCMEncodeNode : 
    public GenericProcessorNode {
  private:
    enum codec_type{PCMU, PCMA};
    codec_type codec;
    
  public:
    PCMEncodeNode(const char* name="PCMEncodeNode",
			  const StreamQueue::Mode queue_mode = StreamQueue::MODE_SUSPEND,
			  const int queue_size = StreamQueue::DEFAULT_SIZE);
    ~PCMEncodeNode(void);

  protected:
    //+++ INode +++
    virtual Result doInit(void);
    virtual Result doDeinit(void);
    virtual Result doInitOutput(void);
    virtual Result doDeinitOutput(void);
    virtual Result doActivate(void);
    virtual Result doDeactivate(void);
    virtual Message* processBuffer(Buffer *in_buffer);

  }; 

}; // namespace NMM

#endif // NMM_PCMUENCODENODE_HPP
