; NMM - Network-Integrated Multimedia Middleware
;
; Copyright (C) 2002-2005
;                    Network-Multimedia Workgroup, 
;                    Computer Graphics Lab,
;                    Saarland University, Germany
;                    http://www.networkmultimedia.org
;
; Maintainer:        Network-Multimedia Workgroup,
;                    http://www.networkmultimedia.org
;
; This library is free software; you can redistribute it and/or
; modify it under the terms of the GNU Lesser General Public
; License as published by the Free Software Foundation; either
; version 2.1 of the License, or (at your option) any later version.
;
; This library is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
; Lesser General Public License for more details.
; 	
; You should have received a copy of the GNU Lesser General Public
; License along with this library; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
; USA
;

%include "c32.mac"

BITS 32

SECTION .data
mystring  db '%d',10,0

BLABLUBB dw 2,1,1,1
ZERO     dw 0,0,0,0

YCOEFF   dw 3736,  19235,  9798, 0
UCOEFF   dw 14221,  -9437, -4784, 0
VCOEFF   dw -3277, -16941, 20218, 0
THREE    dw 3


TEMP     dd 0,0,0,0
MASK     dd 0xFFFFFFFF, 0
SECTION .text


global rgb32_to_YV12_mmx
global rgb24_to_YV12_mmx
global rgb565_to_YV12_mmx

extern printf


%imacro dump_int 1
        pusha
        push  %1
        push  DWORD mystring
        call  printf
        add   esp, 8
        popa
%endmacro

rgb2y:
        push    ebp
        mov     ebp,esp
        push    esi
        push    eax
        push    ebx

        mov     esi, [ebp + 8 ]         ; unsigned char *rgb32_image
        mov     ebx, [ebp + 12]         ; unsigned char *y_plane

        movd    mm0, [esi]
        movq    mm2, mm0
        punpcklbw mm0,  [ZERO]
        pmaddwd mm0, [YCOEFF]
        movq    mm1, mm0
        psrlq   mm1, 32
        pand    mm0, [MASK]
        paddd   mm0, mm1
        psrlq   mm0, 15
        movd    eax, mm0
        mov     [ebx], al               ; store y

        pop     ebx
        pop     eax
        pop     esi
        pop     ebp
        emms
        ret


rgb2uv:
        push    ebp
        mov     ebp,esp
        push    esi
        push    eax
        push    ecx
        push    edx

        mov     esi, [ebp + 8 ]         ; unsigned char *rgb32_image
        mov     ecx, [ebp + 12]         ; unsigned char *u_plane
        mov     edx, [ebp + 16]         ; unsigned char *v_plane

        movd    mm0, [esi]
        punpcklbw mm0, [ZERO]
        movq    mm2, mm0
        pmaddwd mm0, [UCOEFF]
        movq    mm1, mm0
        psrlq   mm1, 32
        pand    mm0, [MASK]
        paddd   mm0, mm1
        psrlq   mm0, 15
        movd    eax, mm0
        add     eax, 128
        mov     [ecx], al               ; store u

        movq    mm0, mm2
        pmaddwd mm0, [VCOEFF]
        movq    mm1, mm0
        psrlq   mm1, 32
        pand    mm0, [MASK]
        paddd   mm0, mm1
        psrlq   mm0, 15
        movd    eax, mm0
        add     eax, 128
        mov     [edx], al               ; store v

        pop     edx
        pop     ecx
        pop     eax
        pop     esi
        pop     ebp
        emms
        ret


rgb32_to_YV12_mmxbla:
        push    ebp
        mov     ebp,esp
        pusha

        sub     esp, 8

        mov     esi, [ ebp + 8  ]       ; unsigned char *rgb32_image
        mov     edi, [ ebp + 12 ]       ; unsigned char *yuv_image
        mov     eax, [ ebp + 16 ]       ; resx
        mul     DWORD [ebp + 20 ]       ; eax *= resy
        add     eax, edi
        mov     [ebp-4 - 40], eax            ; [ebp-4] := yuv_image + resx * resy
        mov     [ebp-8 - 40], eax
        sub     eax, edi
        shr     eax, 2
        add     [ebp-8 - 40], eax            ; [ebp-8] := yuv_image + resx * resy * 5 / 4
        shr     DWORD [ebp+20], 1
        movq    mm3, [ZERO]
.foreachtwolines:
        mov     ecx, [ ebp + 16 ]       ; unsigned int resx
        shr     ecx, 1
.foreach2x2block:
        mov     ebx, [ ebp + 16 ]
        shl     ebx, 2                  ; pitch = resx * 4
        prefetchnta [esi + 8]           ; prefetch next 2x2 block
        prefetchnta [esi + 8 + ebx]
        movq    mm4, [esi]              ; load one 2x2 block into mm4 - mm7
        movq    mm5, mm4
        movq    mm6, [esi + ebx]
        movq    mm7, mm6
        punpcklbw mm4, mm3
        punpckhbw mm5, mm3
        punpcklbw mm6, mm3
        punpckhbw mm7, mm3

        add     esi, 8                  ; next block starts 2 pixels left: skip 8 bytes
        shr     ebx, 2                  ; y pitch is simply resx
        mov     edi, [ ebp + 12 ]       ; unsigned char *yuv_image
 
        movq    mm0, mm4
        pmaddwd mm0, [YCOEFF]
        movq    mm1, mm0
        psrlq   mm1, 32
        pand    mm0, [MASK]
        paddd   mm0, mm1
        psrlq   mm0, 15
        movd    eax, mm0
        mov     [ edi ], al               ; store y1

        movq    mm0, mm5
        pmaddwd mm0, [YCOEFF]
        movq    mm1, mm0
        psrlq   mm1, 32
        pand    mm0, [MASK]
        paddd   mm0, mm1
        psrlq   mm0, 15
        movd    eax, mm0
        mov     [ edi + 1 ], al               ; store y2

        movq    mm0, mm6
        pmaddwd mm0, [YCOEFF]
        movq    mm1, mm0
        psrlq   mm1, 32
        pand    mm0, [MASK]
        paddd   mm0, mm1
        psrlq   mm0, 15
        movd    eax, mm0
        mov     [ ebx + edi ], al               ; store y3

        movq    mm0, mm7
        pmaddwd mm0, [YCOEFF]
        movq    mm1, mm0
        psrlq   mm1, 32
        pand    mm0, [MASK]
        paddd   mm0, mm1
        psrlq   mm0, 15
        movd    eax, mm0
        mov     [ ebx + edi + 1 ], al               ; store y4
        add     DWORD [ ebp + 12 ], 2            ; next yblock should be stored 2 bytes next

        paddw   mm4, mm5
        paddw   mm4, mm6
        paddw   mm4, mm7
        psrlw   mm4, 2

        movq    mm0, mm4
        pmaddwd mm0, [VCOEFF]
        movq    mm1, mm0
        psrlq   mm1, 32
        pand    mm0, [MASK]
        paddd   mm0, mm1
        psrlq   mm0, 15
        movd    eax, mm0
        add     eax, 128
        mov     edi, [ebp-4 - 40]
        mov     [ edi ], al               ; store v
        inc     DWORD [ebp-4 - 40]

        movq    mm0, mm4
        pmaddwd mm0, [UCOEFF]
        movq    mm1, mm0
        psrlq   mm1, 32
        pand    mm0, [MASK]
        paddd   mm0, mm1
        psrlq   mm0, 15
        movd    eax, mm0
        add     eax, 128
        mov     edi, [ebp-8 - 40]
        mov     [ edi ], al               ; store u
        inc     DWORD [ebp-8 - 40]

        dec     ecx
        jnz     .foreach2x2block

        test    DWORD [ebp + 16], 1             ; if resx is odd, just skip the small 2x1 block
        jz      .resxnot_odd
        add     esi, 4
.resxnot_odd:
        add     DWORD [ ebp + 12 ], ebx
        shl     ebx, 2
        add     esi, ebx
        dec     DWORD [ebp+20]                      ; --resy
        jnz     .foreachtwolines

        add     esp, 8
        popa
        pop     ebp
        emms
        ret
;  end of rgb32toYV12_mmx


%macro rgb24_y 1
        movq    mm0, %1
        pmaddwd mm0, [YCOEFF]
        movq    mm1, mm0
        psrlq   mm1, 32
        pand    mm0, [MASK]
        paddd   mm0, mm1
        psrlq   mm0, 15
        movd    eax, mm0
%endmacro

%macro rgb24_u 1
        movq    mm0, %1
        pmaddwd mm0, [UCOEFF]
        movq    mm1, mm0
        psrlq   mm1, 32
        pand    mm0, [MASK]
        paddd   mm0, mm1
        psrlq   mm0, 15
        movd    eax, mm0
        add     eax, 128
%endmacro

%macro rgb24_v 1
        movq    mm0, %1
        pmaddwd mm0, [VCOEFF]
        movq    mm1, mm0
        psrlq   mm1, 32
        pand    mm0, [MASK]
        paddd   mm0, mm1
        psrlq   mm0, 15
        movd    eax, mm0
        add     eax, 128
%endmacro

%macro rgb_to_YV12_mmx 1
        push    ebp
        mov     ebp,esp
        pusha

        sub     esp, 8

        mov     esi, [ ebp + 8  ]       ; unsigned char *rgb24_image
        mov     edi, [ ebp + 12 ]       ; unsigned char *yuv_image
        mov     eax, [ ebp + 16 ]       ; resx
        mul     DWORD [ebp + 20 ]       ; eax *= resy
        add     eax, edi
        mov     [ebp-4 - 40], eax            ; [ebp-4] := vplane = yuv_image + resx * resy
        mov     [ebp-8 - 40], eax

        mov     eax, [ ebp + 16 ]       ; resx
        ;inc     eax
        shr     eax, 1
        mov     ebx, [ ebp + 20 ]       ; resy
        ;inc     ebx
        shr     ebx, 1
        mul     ebx                     ; eax = (resx+0)/2*(resy+0)/2
        add     [ebp-8 - 40], eax       ; [ebp-8] := uplane = vplane + uvplanesize
        shr     DWORD [ebp+20], 1
        movq    mm3, [ZERO]

        mov     eax, [ ebp + 16 ]
        mov     DWORD [ebp + 8], %1
        mul     DWORD [ebp + 8 ]
        mov     ebx, eax                ; ebx = pitch = resx * byteperpixel
        mov     edx, [ ebp + 16 ]       ; edx = resx
.foreachtwolines:
        mov     ecx, [ ebp + 16 ]       ; unsigned int resx
        shr     ecx, 1
.foreach2x2block:
        prefetchnta [esi + 2 * %1]      ; prefetch next 2x2 block
        prefetchnta [esi + 2 * %1 + ebx]
        movd    mm4, [esi]              ; load one 2x2 block into mm4 - mm7
        movd    mm5, [esi+%1]
        movd    mm6, [esi + ebx]
        movd    mm7, [esi + ebx + %1]
        punpcklbw mm4, mm3
        punpcklbw mm5, mm3
        punpcklbw mm6, mm3
        punpcklbw mm7, mm3

        mov     edi, [ ebp + 12 ]       ; unsigned char *yuv_image

        rgb24_y mm4
        mov     [ edi ], al             ; store y1
        rgb24_y mm5
        mov     [ edi + 1 ], al         ; store y2
        rgb24_y mm6
        mov     [ edi + edx ], al       ; store y3
        rgb24_y mm7
        mov     [ edi + edx + 1 ], al   ; store y4

        paddw   mm4, mm5
        paddw   mm4, mm6
        paddw   mm4, mm7
        psrlw   mm4, 2

        rgb24_v mm4
        mov     edi, [ebp-4 - 40]
        mov     [ edi ], al             ; store v
        inc     DWORD [ebp-4 - 40]
        rgb24_u mm4
        mov     edi, [ebp-8 - 40]
        mov     [ edi ], al             ; store u
        inc     DWORD [ebp-8 - 40]

        add     DWORD [ ebp + 12 ], 2   ; next yblock should be stored 2 bytes next
        add     esi, 2 * %1             ; next block starts 2 pixels left: skip 6 bytes
        dec     ecx
        jnz     .foreach2x2block

        add     DWORD [ ebp + 12 ], edx
        add     esi, ebx
        dec     DWORD [ebp+20]
        jnz     .foreachtwolines
        add     esp, 8
        popa
        pop     ebp
        emms
        ret
%endmacro
;  end of rgb24toYV12_mmx

rgb24_to_YV12_mmx:
        rgb_to_YV12_mmx 3

rgb32_to_YV12_mmx:
        rgb_to_YV12_mmx 4


rgb565_to_YV12_mmx:
        dump_int DWORD 1
        push    ebp
        mov     ebp,esp
        pusha

        sub     esp, 8

        mov     esi, [ ebp + 8  ]       ; unsigned char *rgb24_image
        mov     edi, [ ebp + 12 ]       ; unsigned char *yuv_image
        mov     eax, [ ebp + 16 ]       ; resx
        mul     DWORD [ebp + 20 ]       ; eax *= resy
        add     eax, edi
        mov     [ebp-4 - 40], eax            ; [ebp-4] := yuv_image + resx * resy
        mov     [ebp-8 - 40], eax
        sub     eax, edi
        shr     eax, 2
        add     [ebp-8 - 40], eax            ; [ebp-8] := yuv_image + resx * resy * 5 / 4
        shr     DWORD [ebp+20], 1
        movq    mm3, [ZERO]

        mov     eax, [ ebp + 16 ]
        shl     eax, 1
        mov     ebx, eax                ; ebx = pitch = resx * 2
        mov     edx, [ ebp + 16 ]       ; edx = resx
        shr     DWORD [ebp+16], 1
.foreachtwolines:
        mov     ecx, [ ebp + 16 ]       ; unsigned int resx
.foreach2x2block:
        prefetchnta [esi + 4]           ; prefetch next 2x2 block
        prefetchnta [esi + 4 + ebx]
        mov     edi, [esi]              ; load one 2x2 block. edi = first two adjacent pixels

        pxor    mm4, mm4                ; extract pixel 00
        mov     eax, edi
        and     eax, 1111100000000000b
        shr     eax, 8
        pinsrw  mm4, eax, 2

        mov     eax, edi
        and     eax, 0000011111100000b
        shr     eax, 3
        pinsrw  mm4, eax, 1

        mov     eax, edi
        and     eax, 0000000000011111b
        shl     eax, 3
        pinsrw  mm4, eax, 0

        shr     edi, 16                 ; extract pixel 01
        pxor    mm5, mm5
        mov     eax, edi
        and     eax, 1111100000000000b
        shr     eax, 8
        pinsrw  mm5, eax, 2

        mov     eax, edi
        and     eax, 0000011111100000b
        shr     eax, 3
        pinsrw  mm5, eax, 1

        mov     eax, edi
        and     eax, 0000000000011111b
        shl     eax, 3
        pinsrw  mm5, eax, 0

        mov     edi, [esi + ebx]        ; extract pixel 10
        pxor    mm6, mm6
        mov     eax, edi
        and     eax, 1111100000000000b
        shr     eax, 8
        pinsrw  mm6, eax, 2

        mov     eax, edi
        and     eax, 0000011111100000b
        shr     eax, 3
        pinsrw  mm6, eax, 1

        mov     eax, edi
        and     eax, 0000000000011111b
        shl     eax, 3
        pinsrw  mm6, eax, 0

        shr     edi, 16                 ; extract pixel 11
        pxor    mm7, mm7
        mov     eax, edi
        and     eax, 1111100000000000b
        shr     eax, 8
        pinsrw  mm7, eax, 2

        mov     eax, edi
        and     eax, 0000011111100000b
        shr     eax, 3
        pinsrw  mm7, eax, 1

        mov     eax, edi
        and     eax, 0000000000011111b
        shl     eax, 3
        pinsrw  mm7, eax, 0

        mov     edi, [ ebp + 12 ]       ; edi = unsigned char *yuv_image

        movq    mm0, mm4
        pmaddwd mm0, [YCOEFF]
        movq    mm1, mm0
        psrlq   mm1, 32
        pand    mm0, [MASK]
        paddd   mm0, mm1
        psrlq   mm0, 15
        movd    eax, mm0
        mov     [ edi ], al               ; store y1

        movq    mm0, mm5
        pmaddwd mm0, [YCOEFF]
        movq    mm1, mm0
        psrlq   mm1, 32
        pand    mm0, [MASK]
        paddd   mm0, mm1
        psrlq   mm0, 15
        movd    eax, mm0
        mov     [ edi + 1 ], al               ; store y2

        movq    mm0, mm6
        pmaddwd mm0, [YCOEFF]
        movq    mm1, mm0
        psrlq   mm1, 32
        pand    mm0, [MASK]
        paddd   mm0, mm1
        psrlq   mm0, 15
        movd    eax, mm0
        mov     [ edx + edi ], al               ; store y3

        movq    mm0, mm7
        pmaddwd mm0, [YCOEFF]
        movq    mm1, mm0
        psrlq   mm1, 32
        pand    mm0, [MASK]
        paddd   mm0, mm1
        psrlq   mm0, 15
        movd    eax, mm0
        mov     [ edx + edi + 1 ], al               ; store y4

        paddw   mm4, mm5
        paddw   mm4, mm6
        paddw   mm4, mm7
        psrlw   mm4, 2

        movq    mm0, mm4
        pmaddwd mm0, [VCOEFF]
        movq    mm1, mm0
        psrlq   mm1, 32
        pand    mm0, [MASK]
        paddd   mm0, mm1
        psrlq   mm0, 15
        movd    eax, mm0
        add     eax, 128
        mov     edi, [ebp-4 - 40]
        mov     [ edi ], al               ; store v
        inc     DWORD [ebp-4 - 40]

        movq    mm0, mm4
        pmaddwd mm0, [UCOEFF]
        movq    mm1, mm0
        psrlq   mm1, 32
        pand    mm0, [MASK]
        paddd   mm0, mm1
        psrlq   mm0, 15
        movd    eax, mm0
        add     eax, 128
        mov     edi, [ebp-8 - 40]
        mov     [ edi ], al               ; store u
        inc     DWORD [ebp-8 - 40]

        add     DWORD [ ebp + 12 ], 2            ; next yblock should be stored 2 bytes next
        add     esi, 4              ; next block starts 2 pixels left: skip 4 bytes
        dec     ecx
        jnz     .foreach2x2block

        test    DWORD [ebp + 16], 1             ; if resx is odd, just skip the small 2x1 block
        jz      .resxnot_odd
        add     esi, 2
.resxnot_odd:

        add     DWORD [ ebp + 12 ], edx
        add     esi, ebx
        dec     DWORD [ebp+20]                      ; --resy
        jnz     .foreachtwolines

        add     esp, 8
        popa
        pop     ebp
        emms
        ret
;  end of rgb24toYV12_mmx



proc    rgb32toVec4f
        push     esi
        push     edi
        push     eax
        push     ecx
        mov      esi, [ ebp + 8  ]       ; unsigned char *
        mov      edi, [ ebp + 12 ]       ; Vec4f *
        mov      ecx, [ ebp + 16 ]       ; unsigned int n
        mov      DWORD [ebp + 8], 0      ; temp variable
.xxx:
        prefetchnta [ esi + 0x20 ]
        prefetchnta [ edi + 0x20 ]
        mov      eax, [ esi ]

        mov      [ebp + 8 ], ah
        fild     DWORD [ ebp + 8 ]
        fstp     DWORD [ edi ]

        mov      [ebp + 8 ], al
        fild     DWORD [ ebp + 8 ]
        fstp     DWORD [ edi + 4 ]

        shr      eax, 16
        mov      [ebp + 8 ], al
        fild     DWORD [ ebp + 8 ]
        fstp     DWORD [ edi + 8 ]
        add      edi, 16
        add      esi, 4
        dec      ecx

        jnz      .xxx
        pop      ecx
        pop      eax
        pop      edi
        pop      esi
endproc


proc    rgb24toVec4f
        push     esi
        push     edi
        push     eax
        push     ecx
        mov      esi, [ ebp + 8  ]       ; unsigned char *
        mov      edi, [ ebp + 12 ]       ; Vec4f *
        mov      ecx, [ ebp + 16 ]       ; unsigned int n
        mov      DWORD [ebp + 8], 0      ; temp variable
.xxx:
        mov      eax, [ esi ]

        mov      [ebp + 8 ], al
        fild     DWORD [ ebp + 8 ]
        fstp     DWORD [ edi ]

        mov      [ebp + 8 ], ah
        fild     DWORD [ ebp + 8 ]
        fstp     DWORD [ edi + 4 ]

        shr      eax, 16
        mov      [ebp + 8 ], al
        fild     DWORD [ ebp + 8 ]
        fstp     DWORD [ edi + 8 ]
        add      edi, 16
        add      esi, 3
        dec      ecx

        jnz      .xxx
        pop      ecx
        pop      eax
        pop      edi
        pop      esi
endproc

proc    dot3_n
        push     eax
        push     ecx
        push     esi
        push     edi

        mov      esi, [ebp + 0x08 ]       ; Vec4f *transform
        movups   xmm0, [ esi ]
        mov      esi, [ebp + 0x0C ]       ; Vec4f *v
        mov      edi, [ebp + 0x10 ]       ; unsigned char *result
        mov      ecx, [ebp + 0x14 ]       ; n
        sub      esp, 0x20
.xxx
        prefetchnta [ esi + 0x20 ]
        prefetchnta [ edi + 0x20 ]
        movups   xmm2, [ esi ]
        movups   xmm1, xmm0
        mulps    xmm1, xmm2
        movups   [ ebp - 0x24 ], xmm1
        fld      DWORD [ ebp - 0x24 ]
        fadd     DWORD [ ebp - 0x20 ]
        fadd     DWORD [ ebp - 0x1C ]
        fadd     DWORD [ ebp - 0x18 ]
        fistp    DWORD [ ebp - 0x14 ]
        mov      al, [ ebp - 0x14 ]
        mov      [ edi ], al
        add      esi, 4 * 4
        inc      edi
        dec      ecx
        jnz      .xxx
        add      esp, 0x20

        pop      edi
        pop      esi
        pop      ecx
        pop      eax
endproc

proc    dot4_n
        push     eax
        push     ecx
        push     esi
        push     edi

        mov      esi, [ebp + 0x08 ]       ; Vec4f *transform
        movups   xmm0, [ esi ]
        mov      esi, [ebp + 0x0C ]       ; Vec4f *v
        mov      edi, [ebp + 0x10 ]       ; unsigned char *result
        mov      ecx, [ebp + 0x14 ]       ; n
        sub      esp, 0x30
.xxx2:
        prefetchnta [ esi + 0x20 ]
        prefetchnta [ edi + 0x20 ]
        movups   xmm2, [ esi ]
        movups   xmm1, xmm0
        mulps    xmm1, xmm2
        movups   [ ebp - 0x24 ], xmm1
        fld      DWORD [ ebp - 0x34 ]
        fadd     DWORD [ ebp - 0x30 ]
        fadd     DWORD [ ebp - 0x2C ]
        fadd     DWORD [ ebp - 0x28 ]
        fistp    DWORD [ ebp - 0x24 ]
        mov      al, [ ebp - 0x24 ]
        mov      [ edi ], al
        add      esi, 4 * 4
        inc      edi
        dec      ecx
        jnz      .xxx2
        add      esp, 0x30

        pop      edi
        pop      esi
        pop      ecx
        pop      eax
endproc


proc    matrixmult
        mov      edx, [ebp + 0x08 ]       ; edx = Matrix *m, points to first column (m must be column major!)
        mov      esi, [ebp + 0x0C ]       ; esi = Vec4f  *v
        mov      edi, [ebp + 0x10 ]       ; result
        
        movups   xmm4, [ edx ]            ; load columns of matrix into xmm4-7
        movups   xmm5, [ edx + 0x10 ]
        movups   xmm6, [ edx + 0x20 ]
        movups   xmm7, [ edx + 0x30 ]
        movups   xmm0, [ esi ]            ; xmm0 = v

        xorps    xmm2, xmm2               ; xmm2 = Vec4f(0,0,0,0)
        ; broadcast x into xmm1, multiply it by the first
        ; column of the matrix (xmm4), and add it to the total

        movups   xmm1, xmm0
        shufps   xmm1, xmm1, 00000000b
        mulps    xmm1, xmm4
        addps    xmm2, xmm1

        ; repeat the process for y, z and w
        movups   xmm1, xmm0
        shufps   xmm1, xmm1, 01010101b
        mulps    xmm1, xmm5
        addps    xmm2, xmm1

        movups   xmm1, xmm0
        shufps   xmm1, xmm1, 10101010b
        mulps    xmm1, xmm6
        addps    xmm2, xmm1

        movups   xmm1, xmm0
        shufps   xmm1, xmm1, 11111111b
        mulps    xmm1, xmm7
        addps    xmm2, xmm1
        
        movups [ edi ], xmm2              ; store result
endproc

proc matrixmult_n
        mov    edx, [ebp + 0x08 ] ; M, first col
        mov    esi, [ebp + 0x0C ] ; v
        mov    edi, [ebp + 0x10 ] ; result
        mov    ecx, [ebp + 0x14 ] ; len

        movaps xmm4, [edx]
        movaps xmm5, [edx+0x10]
        movaps xmm6, [edx+0x20]
        movaps xmm7, [edx+0x30]
        shr    ecx, 1
.xxx:
        ; process x (hiding the prefetches in the delays)
        movss  xmm1, [esi+0x00]
        movss  xmm3, [esi+0x10]
        shufps xmm1, xmm1, 0x00
        prefetchnta  [edi+0x30]
        shufps xmm3, xmm3, 0x00
        mulps  xmm1, xmm4
        prefetchnta  [esi+0x30]
        mulps  xmm3, xmm4
        ; process y
        movss  xmm0, [esi+0x04]
        movss  xmm2, [esi+0x14]
        shufps xmm0, xmm0, 0x00
        shufps xmm2, xmm2, 0x00
        mulps  xmm0, xmm5
        mulps  xmm2, xmm5
        addps  xmm1, xmm0
        addps  xmm3, xmm2
        ; process z (hiding some pointer arithmetic between
        ; the multiplies)
        movss  xmm0, [esi+0x08]
        movss  xmm2, [esi+0x18]
        shufps xmm0, xmm0, 0x00
        shufps xmm2, xmm2, 0x00
        mulps  xmm0, xmm6
        add    esi, 2 * 4 * 4       ; one Vec4f contains 4 floats -> 4 * 4, two of them -> 2 * 4 * 4
        mulps  xmm2, xmm6
        add    edi, 2 * 4 * 4
        addps  xmm1, xmm0
        addps  xmm3, xmm2

        ; process w
        addps  xmm1, xmm7
        addps  xmm3, xmm7
        ; write output vectors to memory and loop
        movaps [edi-0x20], xmm1
        movaps [edi-0x10], xmm3
        dec    ecx
        jnz    .xxx
endproc


