/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        NMM work group,
 *                    http://www.networkmultimedia.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#ifndef _NMM_YUVBLUESCREEN_HPP_
#define _NMM_YUVBLUESCREEN_HPP_

#include "nmm/base/GenericProcessorNode.hpp"
#include "nmm/base/memorymgr/Buffer.hpp"

namespace NMM {

  class YUVBluescreen : public GenericProcessorNode {
  protected:

    Buffer *processBuffer(Buffer *in_buffer);
    void convertKeyYUV2RGBA (unsigned char *src, int n, unsigned char *dst,
                             bool hard = true,
                             int target_u = 116, int target_v = 116,
                             float edge_factor = 1.0);

  public:
    YUVBluescreen(const char *name = "YUVBluescreen");
    virtual ~YUVBluescreen(){};
    
    void retarget(int u, int v, int y);
    void redistance(float d);
    void refactor(float f, float g);

    void target(int u, int v, int y);
    void distance(float d, float f, float g);
   };
  
}

#endif
