/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:         
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#ifndef _NMM_OSDELEMENT_HPP_
#define _NMM_OSDELEMENT_HPP_

#include "nmm/interfaces/video/osd/manager/IWindow.hpp"
#include "nmm/interfaces/video/osd/manager/IOSDManager.hpp"
#include "nmm/interfaces/video/osd/manager/IWidgetFactory.hpp"

#include "OSDElementBase.hpp"

namespace NMM {
  
  /**
   * Widget unit.
   * Manages a widget. This class is used on the application side only.
   */
  class OSDElement:
    public OSDElementBase {
    
  public:
    OSDElement(IOSDManager* manager, IWidgetFactory* factory);
    virtual ~OSDElement();
    
    Result selectLeft()  { return (SUCCESS); };
    Result selectRight() { return (SUCCESS); };
    Result selectUp()    { return (SUCCESS); };
    Result selectDown()  { return (SUCCESS); };
    string messageID() { return(""); };
    
    void setDimension( unsigned int w, unsigned int h );
    void setPosition( unsigned int x, unsigned int y );
    
    virtual void setHeader(string) {};
    virtual void setColors(uint, uint, uint, uint, uint) {};

    void update() { win->update(); };
    IWindow* getWindow();
    void show();
    void hide();
    bool isHidden();
    
  protected:
    int width, height;
    IOSDManager_var    manager;
    IWidgetFactory_var factory;
    
    IWindow_var        win;
  };
}

#endif
