/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:         
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#ifndef _NMM_DECOSCROLL_HPP_
#define _NMM_DECOSCROLL_HPP_ _NMM_DECOSCROLL_HPP_

#include "decorators.hpp"

#include "nmm/interfaces/video/osd/manager/IScrollDecoratorImpl.hpp"

namespace NMM {
  /*****************************************************************************************/
  /* ScrollDecorator   									   */
  /*****************************************************************************************/
  class ScrollDecorator : virtual public Decorator,
                          virtual public IScrollDecoratorImpl {
  protected:
    unsigned int barwidth;
    unsigned int backgroundcolor;
    unsigned int bordercolor;
    unsigned int barcolor;
    unsigned int barbordercolor1;
    unsigned int barbordercolor2;
    
    void drawFilledBox( unsigned int* frame, unsigned int stride,
                        unsigned int xs, unsigned int ys,
                        unsigned int width, unsigned int height,
			unsigned int color );
    
    void drawBox( unsigned int* frame, unsigned int stride,
                  unsigned int xs, unsigned int ys,
                  unsigned int width, unsigned int height,
                  unsigned int color1, unsigned int color2 );
    
    void drawScrollBar( workspace_t* ws );
    
  public:
    ScrollDecorator();
    
    /** IScrollDecorator interface. */
    virtual void setBarWidth( const unsigned int& bw );
    virtual void setBackgroundColor( const u_int32_t& bcolor );
    virtual void setBorderColor( const u_int32_t& bcolor );
    virtual void setBarColor( const u_int32_t& bcolor );
    virtual void setBarBorderColors( const u_int32_t& bcolor1, const u_int32_t& bcolor2 );
    
    /** Draws Widget with Scrollbar. */
    virtual void draw( workspace_t* ws );
    
  }; // ScrollDecorator
} // NMM

#endif //_NMM_DECOSCROLL_HPP_
