/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:         
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#ifndef _NMM_WGIMAGEVIEW_HPP_
#define _NMM_WGIMAGEVIEW_HPP_ _NMM_WGIMAGEVIEW_HPP_

#include "widgets.hpp"
#include "nmm/interfaces/video/osd/manager/IImageViewImpl.hpp"

namespace NMM {
  
  /**
   * Image view widget.
   */
  class ImageView : virtual public Widget,
                    virtual public IImageViewImpl {
    
  protected:
    BitmapReader*  bitmapreader;
    string         bitmapid;
    
    /**
     * Paint bitmap to workspace with transparency.
     * @param id bitmap identifier
     * @param ws pointer to rgba workspace
     */
    void overlayBitmap( string id, workspace_t* ws );
    
  public:
    ImageView();
    virtual ~ImageView();
    
    /** Set Bitmap reader that handles bitmap identifiers. */
    void setBitmapReader( BitmapReader* br );
    
    /** IImageView interface. */
    void setBitmapID( const string& id );
    
    void draw( workspace_t* ws );
  }; // ImageView
}

#endif //_NMM_WGIMAGEVIEW_HPP_
