/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:         
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#include "radiobuttons.hpp"
#include "nmm/misc/overlay/overlay.h"

namespace NMM {

  /*****************************************************************************************/
  /* RadioButtons							                         */
  /*****************************************************************************************/

  RadioButtons::RadioButtons() {
  }

  RadioButtons::~RadioButtons() {
  }

  void RadioButtons::activateButton( const int& buttonid ) {

    /* first deactivate all Buttons */
    Buttons::deactivateAllButtons();

    /* then activate Button */
    Buttons::activateButton( buttonid );
  }

  void RadioButtons::selectPush() {
    /* first deactivate all Buttons */
    Buttons::deactivateAllButtons();

    /* then activate selected Button */
    Buttons::selectPush();
  }

}
