/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        Christoph Wellner <chwellner@graphics.cs.uni-sb.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#ifndef WEBREQUESTHANDLER_HPP
#define WEBREQUESTHANDLER_HPP WEBREQUESTHANDLER_HPP

#include "WebServerRequest.hpp"
#include "WebServerResponse.hpp"

namespace NMM{
  class WebRequestHandler{
  private:
    string handlerUri;
    
  public:
    WebRequestHandler(string uri){ handlerUri = uri;}
    virtual  ~WebRequestHandler(){}

    virtual void doGet (WebServerRequest *pRequest, WebServerResponse *pResponse) =0;
    virtual void doPost(WebServerRequest *pRequest, WebServerResponse *pResponse) =0;
    
    string getURI(){return handlerUri;}

  };
}
#endif
